//
//   Copyright (c) 1999-2000 Intel Corporation.
//
// Permition is granted to use, copy, distribute and prepare derivative works 
// of this library for any purpose and without fee, provided, that the above 
// copyright notice and this statement appear in all copies.  
// Intel makes no representations about the suitability of this software for 
// any purpose, and specifically disclaims all warranties. 
// See LEGAL.TXT for all the legal information.
//

#ifndef _BEZIER_TESSALATION_H_
#define _BEZIER_TESSALATION_H_

#include <windows.h>

#define MAX_TESSELATION_LEVEL 25


class CBezierTessalation {
public:
	struct TessLevel {
		DWORD	m_level;
		LPWORD	m_indices;
		DWORD	m_indicesCount;
		float	*m_teslValues;
		DWORD	m_teslValuesSkip;
	} *m_tessLevels[MAX_TESSELATION_LEVEL];

	CBezierTessalation();
	virtual ~CBezierTessalation();

protected:
	virtual void GenerateTessalationLevel(TessLevel *level);
	virtual void DestroyTessalationLevel(TessLevel *level);

public:

	TessLevel *GetTessalationLevel(DWORD level);

};


#endif
