/*
	The Universe Development Kit
	Copyright (C) 2000  Sean O'Neil
	soneil@home.com

	This library is free software; you can redistribute it and/or
	modify it under the terms of the GNU Lesser General Public
	License as published by the Free Software Foundation; either
	version 2.1 of the License, or (at your option) any later version.

	This library is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
	Lesser General Public License for more details.

	You should have received a copy of the GNU Lesser General Public
	License along with this library; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

// Standard C includes
#define STRICT
#define WIN32_LEAN_AND_MEAN
#include <windows.h>
#include <winuser.h>
#include <pbt.h>
#include <mmsystem.h>
#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <GL\GL.h>
#include <GL\GLU.h>

// Defines and macros
#define _MAX_NAME			31
#define GAME_SECTION		"Game Engine"
#define DISPLAY_SECTION		"Display Engine"
#define SOUND_SECTION		"Sound Engine"
#define INPUT_SECTION		"Input Engine"

// Some physics defines
#define GRAVCONST		6.67259e-20f	// Gravitational constant of the universe (km3 / kg sec2)
#define LIGHTSPEED		299792.458f		// Speed of light (km / sec)
#define EARTH_RADIUS	6378.0f			// The radius of Earth (km)
#define EARTH_MASS		5.9736e24f		// The mass of Earth (kg)
#define MOON_RADIUS		1738.0f			// The radius of Earth's moon (km)
#define MOON_MASS		7.35e22f		// The mass of Earth's moon (kg)
#define MOON_ORBIT		384400.0f		// The moon's distance from Earth (km)

// My includes
#include "WndClass.h"
#include "ListTemplates.h"
