// NURBSSample.cpp - Created with DR&E AppWizard 1.0B8
// ------------------------------------------------------------------------------------
// Copyright  1999 Intel Corporation
// All Rights Reserved
// 
// Permission is granted to use, copy, distribute and prepare derivative works of this 
// software for any purpose and without fee, provided, that the above copyright notice
// and this statement appear in all copies.  Intel makes no representations about the
// suitability of this software for any purpose.  This software is provided "AS IS." 
//
// Intel specifically disclaims all warranties, express or implied, and all liability,
// including consequential and other indirect damages, for the use of this software, 
// including liability for infringement of any proprietary rights, and including the 
// warranties of merchantability and fitness for a particular purpose.  Intel does not
// assume any responsibility for any errors which may appear in this software nor any
// responsibility to update it.
// ------------------------------------------------------------------------------------
//
// PURPOSE:
//    
// NURBSSample.cpp: implementation the NURBSSample class.
// ------------------------------------------------------------------------------------
//
// Author: Dean Macri - Intel Developer Relations Divison -- Tools and Technology Group
//
////////////////////////////////////////////////////////////////////////////////////////

#include "DRGShell.h"

Point4D CPs[16] = {
	{ 3.0f,0.0f,-3.0f,1.0f },
	{ 1.0f,0.0f,-3.0f,1.0f },
	{-1.0f,0.0f,-3.0f,1.0f },
	{-3.0f,0.0f,-3.0f,1.0f },

	{ 3.0f,0.0f,-1.0f,1.0f },
	{ 1.0f,0.0f,-1.0f,1.0f },
	{-1.0f,0.0f,-1.0f,1.0f },
	{-3.0f,0.0f,-1.0f,1.0f },

	{ 3.0f,0.0f,1.0f,1.0f },
	{ 1.0f,0.0f,1.0f,1.0f },
	{-1.0f,0.0f,1.0f,1.0f },
	{-3.0f,0.0f,1.0f,1.0f },

	{ 3.0f,0.0f,3.0f,1.0f },
	{ 1.0f,0.0f,3.0f,1.0f },
	{-1.0f,0.0f,3.0f,1.0f },
	{-3.0f,0.0f,3.0f,1.0f }
};

float UKnots[] = {0,0,0,0,1,1,1,1};
float VKnots[] = {0,0,0,0,1,1,1,1};

Point4D CPs2[100] = {
	{ 3.0f,0.0f,-3.0f,1.0f }, { 2.3f,0.0f,-3.0f,1.0f}, { 1.6f,0.0f,-3.0f,1.0f},
	{ 1.0f,0.0f,-3.0f,1.0f }, { 0.3f,0.0f,-3.0f,1.0f}, {-0.3f,0.0f,-3.0f,1.0f},
	{-1.0f,0.0f,-3.0f,1.0f }, {-1.6f,0.0f,-3.0f,1.0f}, {-2.3f,0.0f,-3.0f,1.0f},
	{-3.0f,0.0f,-3.0f,1.0f },

	{ 3.0f,0.0f,-2.3f,1.0f }, { 2.3f,0.0f,-2.3f,1.0f}, { 1.6f,0.0f,-2.3f,1.0f},
	{ 1.0f,0.0f,-2.3f,1.0f }, { 0.3f,0.0f,-2.3f,1.0f}, {-0.3f,0.0f,-2.3f,1.0f},
	{-1.0f,0.0f,-2.3f,1.0f }, {-1.6f,0.0f,-2.3f,1.0f}, {-2.3f,0.0f,-2.3f,1.0f},
	{-3.0f,0.0f,-2.3f,1.0f },

	{ 3.0f,0.0f,-1.6f,1.0f }, { 2.3f,0.0f,-1.6f,1.0f}, { 1.6f,0.0f,-1.6f,1.0f},
	{ 1.0f,0.0f,-1.6f,1.0f }, { 0.3f,0.0f,-1.6f,1.0f}, {-0.3f,0.0f,-1.6f,1.0f},
	{-1.0f,0.0f,-1.6f,1.0f }, {-1.6f,0.0f,-1.6f,1.0f}, {-2.3f,0.0f,-1.6f,1.0f},
	{-3.0f,0.0f,-1.6f,1.0f },

	{ 3.0f,0.0f,-1.0f,1.0f }, { 2.3f,0.0f,-1.0f,1.0f}, { 1.6f,0.0f,-1.0f,1.0f}, 
	{ 1.0f,0.0f,-1.0f,1.0f }, { 0.3f,0.0f,-1.0f,1.0f}, {-0.3f,0.0f,-1.0f,1.0f},
	{-1.0f,0.0f,-1.0f,1.0f }, {-1.6f,0.0f,-1.0f,1.0f}, {-2.3f,0.0f,-1.0f,1.0f},
	{-3.0f,0.0f,-1.0f,1.0f },

	{ 3.0f,0.0f,-0.3f,1.0f }, { 2.3f,0.0f,-0.3f,1.0f}, { 1.6f,0.0f,-0.3f,1.0f}, 
	{ 1.0f,0.0f,-0.3f,1.0f }, { 0.3f,0.0f,-0.3f,1.0f}, {-0.3f,0.0f,-0.3f,1.0f},
	{-1.0f,0.0f,-0.3f,1.0f }, {-1.6f,0.0f,-0.3f,1.0f}, {-2.3f,0.0f,-0.3f,1.0f},
	{-3.0f,0.0f,-0.3f,1.0f },

	{ 3.0f,0.0f, 0.6f,1.0f }, { 2.3f,0.0f, 0.6f,1.0f}, { 1.6f,0.0f, 0.6f,1.0f}, 
	{ 1.0f,0.0f, 0.6f,1.0f }, { 0.3f,0.0f, 0.6f,1.0f}, {-0.3f,0.0f, 0.6f,1.0f},
	{-1.0f,0.0f, 0.6f,1.0f }, {-1.6f,0.0f, 0.6f,1.0f}, {-2.3f,0.0f, 0.6f,1.0f},
	{-3.0f,0.0f, 0.6f,1.0f },

	{ 3.0f,0.0f,1.0f,1.0f }, { 2.3f,0.0f, 1.0f,1.0f}, { 1.6f,0.0f, 1.0f,1.0f},
	{ 1.0f,0.0f,1.0f,1.0f }, { 0.3f,0.0f, 1.0f,1.0f}, {-0.3f,0.0f, 1.0f,1.0f},
	{-1.0f,0.0f,1.0f,1.0f }, {-1.6f,0.0f, 1.0f,1.0f}, {-2.3f,0.0f, 1.0f,1.0f},
	{-3.0f,0.0f,1.0f,1.0f },

	{ 3.0f,0.0f,1.6f,1.0f }, { 2.3f,0.0f, 1.6f,1.0f}, { 1.6f,0.0f, 1.6f,1.0f},
	{ 1.0f,0.0f,1.6f,1.0f }, { 0.3f,0.0f, 1.6f,1.0f}, {-0.3f,0.0f, 1.6f,1.0f},
	{-1.0f,0.0f,1.6f,1.0f }, {-1.6f,0.0f, 1.6f,1.0f}, {-2.3f,0.0f, 1.6f,1.0f},
	{-3.0f,0.0f,1.6f,1.0f },

	{ 3.0f,0.0f,2.3f,1.0f }, { 2.3f,0.0f, 2.3f,1.0f}, { 1.6f,0.0f, 2.3f,1.0f},
	{ 1.0f,0.0f,2.3f,1.0f }, { 0.3f,0.0f, 2.3f,1.0f}, {-0.3f,0.0f, 2.3f,1.0f},
	{-1.0f,0.0f,2.3f,1.0f }, {-1.6f,0.0f, 2.3f,1.0f}, {-2.3f,0.0f, 2.3f,1.0f},
	{-3.0f,0.0f,2.3f,1.0f },

	{ 3.0f,0.0f,3.0f,1.0f }, { 2.3f,0.0f, 3.0f,1.0f}, { 1.6f,0.0f, 3.0f,1.0f},
	{ 1.0f,0.0f,3.0f,1.0f }, { 0.3f,0.0f, 3.0f,1.0f}, {-0.3f,0.0f, 3.0f,1.0f},
	{-1.0f,0.0f,3.0f,1.0f }, {-1.6f,0.0f, 3.0f,1.0f}, {-2.3f,0.0f, 3.0f,1.0f},
	{-3.0f,0.0f,3.0f,1.0f }
};

float UKnots2[] = {0,0,0,0,1,2,3,4,5,6,7,7,7,7};
float VKnots2[] = {0,0,0,0,1,2,3,4,5,6,7,7,7,7};

static float fTime = 0.0f;

extern CDRGTexture *g_pCFontTexture;	// In Main.cpp

// -----------------------------------------------------------------------
// CNURBSSample::CNURBSSample() 
// The NURBSSample class constructor initializes some of it's member vars (which
// are instances of the DRGMatrix class
// -----------------------------------------------------------------------
CNURBSSample::CNURBSSample()
{
	m_MxWorld.SetIdentity();
	//set the camera at 0,2,-2.5; the target at 0,0,0 and the up vector at 0,1,0
	m_MxView.SetView( DRGVector( 0, 2, -2.5 ), DRGVector( 0, 0, 0 ), DRGVector( 0, 1, 0 ) );
	//set the projection matrix to 1.57 field of view (radians), 1.33 aspect ratio 
	// (640x480), //the near clip plane to 1 and the far to clip plane 100
	m_MxProjection.SetProjection( 1.57f, 1.333f, 1.0f, 100.0f );

	
	m_pDefaultTexture = NULL;

	m_pDefaultMaterial = NULL;

	m_pSampleRootObj1 = NULL;
	m_pSampleRootObj2 = NULL;
	for( int i=0; i<9; i++)
		m_pSampleNURBSSurface[i] = NULL;
	m_pSampleNURBSSurface2 = NULL;


	m_bWireframe = false;
	m_bUseSSE = false;
	m_bUseTextures = true;	
	m_bOnePatch = true;
	m_iTessellationLevel = 10;
}

// -----------------------------------------------------------------------
// CNURBSSample::~CNURBSSample()
// destructor does nothing for now.
// -----------------------------------------------------------------------
CNURBSSample::~CNURBSSample()
{
	//
	// Delete the root -- this will delete all it's children (including the 
	// NURBS surfaces )
	//
	delete m_pSampleRootObj1;
	delete m_pSampleRootObj2;
}

// -----------------------------------------------------------------------
// HRESULT CNURBSSample::InitWorld( CDRGWrapper *pWrapper )
//
// -----------------------------------------------------------------------
HRESULT CNURBSSample::InitWorld( CDRGWrapper *pWrapper )
{
	//
	// Make local copy of the pointer to the wrapper class
	//
	m_pWrapper = pWrapper;

	//
	// function to setup the verts for two triangles that make a background
	SetupSampleBackgroundVerts();
	m_bDrawBackground = true;





	
	//
	// Create a new texture, and init it, with an alpha channel. 
	// (try swapping the flag field in the line below for the remmed
	// one to compare the quality of a 4444 vs 8888 ARGB texture, if 
	// your device supports it (if the device doesn't, it will get 
	// converted to a supported format automatically))
	//
	m_pDefaultTexture = new CDRGTexture;

	if( m_pDefaultTexture->CreateTexture( CBMPLoader( CFileStream( "Images\\Checker.bmp" ) ),
										  (DWORD)0, (DWORD)0/*DRGTEXTR_32BITSPERPIXEL*/) == S_OK )

		m_pDefaultTexture->Restore(pWrapper->m_pD3DDevice7);
	

	m_pSampleRootObj1		= new CDRGObject;
	m_pSampleRootObj1->Init(pWrapper, NULL, NULL, 0, 0,						 
					DRGVector(0.0f,0.0f,0.0f), DRGVector(1.0f), DRGVector(0.0f,1.0f,0.0f), 0.0f,
					DRGVector(0.0f),  DRGVector(0.0f),  0.0f,
					0x0);
	m_pSampleRootObj2		= new CDRGObject;
	m_pSampleRootObj2->Init(pWrapper, NULL, NULL, 0, 0,						 
					DRGVector(0.0f,0.0f,0.0f), DRGVector(1.0f), DRGVector(0.0f,1.0f,0.0f), 0.0f,
					DRGVector(0.0f),  DRGVector(0.0f),  0.0f,
					0x0);

	for( int i=0; i<9; i++ )
	{
		m_pSampleNURBSSurface[i] = new CDRGNURBSSurface;
		m_pSampleNURBSSurface[i]->Init(pWrapper, 3, 3, 4, 4, CPs, UKnots, VKnots, m_iTessellationLevel, m_iTessellationLevel );
		m_pSampleNURBSSurface[i]->m_vScale = DRGVector( 1.0f/6.0f, 1.0f/6.0f, 1.0f/6.0f );
		m_pSampleNURBSSurface[i]->m_vPosition = DRGVector( (float)((i%3)-1), 0.0f, (float)(i/3-1) );
		m_pSampleRootObj1->AddChild( m_pSampleNURBSSurface[i] );
	}
	m_pSampleNURBSSurface2 = new CDRGNURBSSurface;
	m_pSampleNURBSSurface2->Init(pWrapper, 3, 3, 10, 10, CPs2, UKnots2, VKnots2, m_iTessellationLevel*3, m_iTessellationLevel*3 );
	m_pSampleNURBSSurface2->m_vScale = DRGVector( 1.0f/2.0f, 1.0f/6.0f, 1.0f/2.0f );
	m_pSampleRootObj2->AddChild( m_pSampleNURBSSurface2 );

	m_pStatText = new CDRGText;
	m_pStatText->Init( pWrapper );
	m_pStatText->SetFontTexture( g_pCFontTexture );

	m_pStatText->CreateString("Tessellations:", 0.0f, 0.85f, 0.035f, 0.05f, 50, &m_StatStringArray[0]);
	m_pStatText->CreateString("10 ",			0.5f, 0.85f, 0.035f, 0.05f, 50, &m_StatStringArray[1]);
	m_pStatText->CreateString("Use SSE:",		0.0f, 0.9f,  0.035f, 0.05f, 50, &m_StatStringArray[2]);
	m_pStatText->CreateString("No ",			0.5f, 0.9f,  0.035f, 0.05f, 50, &m_StatStringArray[3]);



	//now we call target changed, which sets up device dependant items
	TargetChanged();
	
	return S_OK;
}

// -----------------------------------------------------------------------
// HRESULT CNURBSSample::DestroyWorld( void )
//
// -----------------------------------------------------------------------
HRESULT CNURBSSample::DestroyWorld( void )
{
	return S_OK;
}

// -----------------------------------------------------------------------
// HRESULT CNURBSSample::UpdateWorld( DWORD dwTime, int InputFlag )
//
// -----------------------------------------------------------------------
HRESULT CNURBSSample::UpdateWorld()
{

	//Call the Update method of the object at the root of our hierarchy,
	// specifying to propogate the update down the hierarchy. This will
	// update all the objects positions/orientations according to their
	// velocities. By specifying the frame time, our animation speed is
	// independant of frame rate
	if( m_bOnePatch )
	{
		if(m_pSampleRootObj2)
			m_pSampleRootObj2->Update(m_pWrapper->m_fFrameTime, true);
	}
	else if(m_pSampleRootObj1)
		m_pSampleRootObj1->Update(m_pWrapper->m_fFrameTime, true);

	for( int i=0; i<9; i++ )
	{
		if( m_pSampleNURBSSurface[i] )
		{
			fTime += m_pWrapper->m_fFrameTime;
			CPs[5].y = (float)sin( 3.14159 * fTime * ( 0.3f/(float)(i+1)) ) * 15.0f;
			m_pSampleNURBSSurface[i]->UpdateControlPoints( CPs );
		}
	}
	if( m_pSampleNURBSSurface2 )
	{
		fTime += m_pWrapper->m_fFrameTime;
		CPs2[17].y = (float)sin( 3.14159 * fTime * 0.3f/1.0f ) * 15.0f;
		CPs2[14].y = (float)sin( 3.14159 * fTime * 0.3f/2.0f ) * 15.0f;
		CPs2[11].y = (float)sin( 3.14159 * fTime * 0.3f/3.0f ) * 15.0f;

		CPs2[47].y = (float)sin( 3.14159 * fTime * 0.3f/4.0f ) * 15.0f;
		CPs2[44].y = (float)sin( 3.14159 * fTime * 0.3f/5.0f ) * 15.0f;
		CPs2[41].y = (float)sin( 3.14159 * fTime * 0.3f/6.0f ) * 15.0f;

		CPs2[77].y = (float)sin( 3.14159 * fTime * 0.3f/7.0f ) * 15.0f;
		CPs2[74].y = (float)sin( 3.14159 * fTime * 0.3f/8.0f ) * 15.0f;
		CPs2[71].y = (float)sin( 3.14159 * fTime * 0.3f/9.0f ) * 15.0f;

		m_pSampleNURBSSurface2->UpdateControlPoints( CPs2 );
	}

	return S_OK;
}

// -----------------------------------------------------------------------
// HRESULT CNURBSSample::RenderWorld( void )
//
// -----------------------------------------------------------------------
HRESULT CNURBSSample::RenderWorld( void )
{
	HRESULT hr;

	//
	// Draw two triangles that make up the background
	//
	if (m_bDrawBackground) 
	{
		//disable texture
		hr = m_pWrapper->m_pD3DDevice7->SetTexture( 0, NULL);	
		//draw background
		hr = m_pWrapper->m_pD3DDevice7->DrawPrimitive( D3DPT_TRIANGLELIST, D3DFVF_TLVERTEX,
			m_SampleBackgroundVerts, NUMSAMPLEBACKGROUNDVERTS, 0);		
	}



	hr = m_pWrapper->m_pD3DDevice7->SetRenderState(D3DRENDERSTATE_CULLMODE , D3DCULL_NONE );
	hr = m_pWrapper->m_pD3DDevice7->SetTexture( m_pDefaultTexture->dwStage, NULL);	
	
	hr = m_pWrapper->m_pD3DDevice7->SetRenderState( D3DRENDERSTATE_ALPHABLENDENABLE,   FALSE );

	hr = m_pWrapper->m_pD3DDevice7->SetTextureStageState( m_pDefaultTexture->dwStage, D3DTSS_MINFILTER, D3DTFN_LINEAR );
	hr = m_pWrapper->m_pD3DDevice7->SetTextureStageState( m_pDefaultTexture->dwStage, D3DTSS_MAGFILTER, D3DTFN_LINEAR );
		
	hr = m_pWrapper->m_pD3DDevice7->SetTextureStageState( m_pDefaultTexture->dwStage, D3DTSS_COLORARG1, D3DTA_TEXTURE );
	hr = m_pWrapper->m_pD3DDevice7->SetTextureStageState( m_pDefaultTexture->dwStage, D3DTSS_COLORARG2, D3DTA_CURRENT);
	hr = m_pWrapper->m_pD3DDevice7->SetTextureStageState( m_pDefaultTexture->dwStage, D3DTSS_COLOROP,   D3DTOP_MODULATE );	


	hr = m_pWrapper->m_pD3DDevice7->SetRenderState( D3DRENDERSTATE_DITHERENABLE, TRUE );
	hr = m_pWrapper->m_pD3DDevice7->SetRenderState( D3DRENDERSTATE_SPECULARENABLE, FALSE );


	if( m_bWireframe )
		m_pWrapper->m_pD3DDevice7->SetRenderState( D3DRENDERSTATE_FILLMODE, D3DFILL_WIREFRAME );

	if( m_bOnePatch )
	{
		if(m_pSampleRootObj2)
			hr = m_pSampleRootObj2->Render(m_MxWorld,true);
	}
	else if(m_pSampleRootObj1)
		hr = m_pSampleRootObj1->Render(m_MxWorld,true);

	m_pWrapper->m_pD3DDevice7->SetRenderState( D3DRENDERSTATE_FILLMODE, D3DFILL_SOLID );
	
	//
	// Draw our NURBS statistics
	//
	m_pStatText->DrawText();

	return S_OK;
}


// -----------------------------------------------------------------------
// HRESULT CNURBSSample::TargetChanged( void )
//
// -----------------------------------------------------------------------
HRESULT CNURBSSample::TargetChanged( void )
{
	HRESULT hr;
	//
	// This indicates that the devices of the DRGWrapper class have changed.
	// If you have anything that depends on the current rendering device, you'll
	// have to re-initialize it here
	//
	m_pWrapper->m_pD3DDevice7->SetRenderState( D3DRENDERSTATE_DITHERENABLE, TRUE );

	m_pWrapper->m_pD3DDevice7->SetTransform( D3DTRANSFORMSTATE_WORLD, &m_MxWorld.m_Mx );
	m_pWrapper->m_pD3DDevice7->SetTransform( D3DTRANSFORMSTATE_VIEW, &m_MxView.m_Mx );
	m_pWrapper->m_pD3DDevice7->SetTransform( D3DTRANSFORMSTATE_PROJECTION, &m_MxProjection.m_Mx );

	//
	// re-setup background for new screen res
	//
	SetupSampleBackgroundVerts();

	hr = SetupDependantItems();

	return hr;
}

HRESULT CNURBSSample::SetupDependantItems(void)
{
	HRESULT hr;


	//restore texture
	if (m_pDefaultTexture)
		m_pDefaultTexture->Restore(m_pWrapper->m_pD3DDevice7);

	if(m_pSampleRootObj1)
		hr = m_pSampleRootObj1->TargetChanged(m_pWrapper, true);
	if(m_pSampleRootObj2)
		hr = m_pSampleRootObj2->TargetChanged(m_pWrapper, true);

	//create a default material
	D3DMATERIAL7	*ptempmat = new D3DMATERIAL7;
	ZeroMemory( ptempmat, sizeof(D3DMATERIAL7) );
  
	ptempmat->ambient.r = 0.7f;    ptempmat->ambient.g = 0.7f;    ptempmat->ambient.b = 0.7f;
	ptempmat->diffuse.r = 1.0f;    ptempmat->diffuse.g = 1.0f;    ptempmat->diffuse.b = 1.0f;
	ptempmat->specular.r = 1.0f;    ptempmat->specular.g = 1.0f;    ptempmat->specular.b = 1.0f;

	if( FAILED( hr = m_pWrapper->m_pD3DDevice7->SetMaterial(ptempmat) ) )
		return hr;



	m_pDefaultMaterial = new CDRGMaterial;
		
	m_pDefaultMaterial->SetMaterial(ptempmat);
	m_pDefaultMaterial->SetTexture(m_pDefaultTexture);
	
	m_pSampleRootObj1->SetMaterial(m_pDefaultMaterial);
	m_pSampleRootObj2->SetMaterial(m_pDefaultMaterial);


	
	// Set up a default light
    D3DLIGHT7 light;
    ZeroMemory( &light, sizeof(light) );
    light.dltType       = D3DLIGHT_DIRECTIONAL;
    light.dcvDiffuse.r  = 0.9f;
    light.dcvDiffuse.g  = 0.9f;
    light.dcvDiffuse.b  = 0.9f;
    light.dvRange       = D3DLIGHT_RANGE_MAX;
    
    light.dvDirection    = D3DVECTOR( 0.2f, -0.9f, -0.2f);

    // Set the light
    if( FAILED(m_pWrapper->m_pD3DDevice7->SetLight( 0, &light )))
		return hr;

	if( FAILED(m_pWrapper->m_pD3DDevice7->LightEnable( 0, TRUE )))
		return hr;

    if( FAILED(m_pWrapper->m_pD3DDevice7->SetRenderState( D3DRENDERSTATE_LIGHTING, TRUE )))
		return hr;

	if( FAILED(m_pWrapper->m_pD3DDevice7->SetRenderState( D3DRENDERSTATE_AMBIENT, 0xff333333 ) ) )
		return hr;
	
	if (FAILED(hr = m_pWrapper->m_pD3DDevice7->SetRenderState(D3DRENDERSTATE_COLORVERTEX, TRUE) ))
		return hr;

	return S_OK;
}

// -----------------------------------------------------------------------
// void CNURBSSample::SetupBackGroundVerts(float scale)
//
//   this is just a function that sets up a pool of member verts as an axis
//   at the center of the world.
// -----------------------------------------------------------------------

void CNURBSSample::SetupSampleBackgroundVerts()
{
	memset( m_SampleBackgroundVerts, 0, sizeof( D3DTLVERTEX ) * NUMSAMPLEBACKGROUNDVERTS );

	float width = float( m_pWrapper->m_dwRenderWidth);
	float height = float( m_pWrapper->m_dwRenderHeight);

	float margin = 0.01f;

	m_SampleBackgroundVerts[0].sx = 0.0f + margin;	m_SampleBackgroundVerts[0].sy = 0.0f + margin;	
	m_SampleBackgroundVerts[1].sx = width - margin;	m_SampleBackgroundVerts[1].sy = height - margin;
	m_SampleBackgroundVerts[2].sx = 0.0f + margin;	m_SampleBackgroundVerts[2].sy = height - margin;	
	m_SampleBackgroundVerts[3].sx = 0.0f + margin;	m_SampleBackgroundVerts[3].sy = 0.0f + margin;	
	m_SampleBackgroundVerts[4].sx = width - margin;	m_SampleBackgroundVerts[4].sy = 0.0f + margin;	
	m_SampleBackgroundVerts[5].sx = width - margin;	m_SampleBackgroundVerts[5].sy = height - margin;	
		
	// common elements
	for (int i=0;i<NUMSAMPLEBACKGROUNDVERTS;i++)
	{
		m_SampleBackgroundVerts[i].sz = 0.99999f;
		m_SampleBackgroundVerts[i].rhw = 0.00001f;
		m_SampleBackgroundVerts[i].tu = 0.5f;
		m_SampleBackgroundVerts[i].tv = 0.5f;	
		m_SampleBackgroundVerts[i].dcSpecular = 0;
		m_SampleBackgroundVerts[i].dcColor = D3DRGB( 0.1, 0.1, 0.1 );
	}

	// color the top of the Background differently (R,G,B for X,Y,Z)
	// (rem out the three lines below for mono colored background)
	m_SampleBackgroundVerts[0].dcColor = D3DRGB( 0.45, 0.45, 0.45 );
	m_SampleBackgroundVerts[3].dcColor = D3DRGB( 0.45, 0.45, 0.45 );
	m_SampleBackgroundVerts[4].dcColor = D3DRGB( 0.45, 0.45, 0.45 );
	
	return;

}














// -----------------------------------------------------------------------
// void CNURBSSample::KeyUp(WPARAM wParam)
//
//   Keyboard keypress handler. 
// -----------------------------------------------------------------------
void CNURBSSample::KeyDown(WPARAM wParam)
{
	//we need a variable to modify our rotation speed with frame rate	
	float scaler = 1.0f;
	int i;
	char szTemp[5];

	//if exiting, the wrapper could be invalid, but we don't care, since we will exit anyway
	if (wParam == 'X') 
		return;

	if(m_pWrapper) //we could get into this loop after the wrapper has been invalidates
	{
		if (m_pWrapper->m_fFrameTime >0.0f)
			scaler = m_pWrapper->m_fFrameTime;  
	}
		
	switch (wParam) 
	{
	case 'W':
		m_bWireframe = !m_bWireframe;
		break;

#if SUPPORT_PENTIUM_III
	case 'S':
		m_bUseSSE = !m_bUseSSE;
		for( i=0; i<9; i++ )
			m_pSampleNURBSSurface[i]->SetUseSSE( m_bUseSSE );
		m_bUseSSE = m_pSampleNURBSSurface2->SetUseSSE( m_bUseSSE );
		sprintf( szTemp, "%s", m_bUseSSE ? "Yes" : "No " );
		m_pStatText->ModifyStringContent(m_StatStringArray[3], szTemp );
		break;
#endif

	case 'T':
		m_bUseTextures = !m_bUseTextures;
		if( m_bUseTextures )
			m_pDefaultMaterial->SetTexture(m_pDefaultTexture);
		else
			m_pDefaultMaterial->SetTexture(NULL);
		break;

	case 'M':
		m_bOnePatch = !m_bOnePatch;
		break;

	case 0xbb:	// We should be doing some keyboard translation -- this is a '+'
	case VK_ADD:
		if( m_iTessellationLevel < 100 )
			m_iTessellationLevel++;
		for( i=0; i<9; i++ )
			m_pSampleNURBSSurface[i]->SetTessellations( m_iTessellationLevel, m_iTessellationLevel );
		m_pSampleNURBSSurface2->SetTessellations( m_iTessellationLevel*3, m_iTessellationLevel*3 );
		sprintf( szTemp, "%-3d", m_iTessellationLevel );
		m_pStatText->ModifyStringContent(m_StatStringArray[1],szTemp);
		break;
	case 0xbd:
	case VK_SUBTRACT:
		if( m_iTessellationLevel > 4 )
			m_iTessellationLevel--;
		for( i=0; i<9; i++ )
			m_pSampleNURBSSurface[i]->SetTessellations( m_iTessellationLevel, m_iTessellationLevel );
		m_pSampleNURBSSurface2->SetTessellations( m_iTessellationLevel*3, m_iTessellationLevel*3 );
		sprintf( szTemp, "%-3d", m_iTessellationLevel );
		m_pStatText->ModifyStringContent(m_StatStringArray[1],szTemp);
		break;

	case VK_UP:
		m_MxView.Rotate( m_MxView.m_Mx._11, m_MxView.m_Mx._21, m_MxView.m_Mx._31, -3.14159f*scaler );
		break;
	
	case VK_DOWN:
		m_MxView.Rotate( m_MxView.m_Mx._11, m_MxView.m_Mx._21, m_MxView.m_Mx._31, 3.14159f*scaler );
		break;
	
	case VK_LEFT:
		m_MxView.Rotate( m_MxView.m_Mx._12, m_MxView.m_Mx._22, m_MxView.m_Mx._32, -3.14159f*scaler );
		break;
	
	case VK_RIGHT:	
		m_MxView.Rotate( m_MxView.m_Mx._12, m_MxView.m_Mx._22, m_MxView.m_Mx._32, 3.14159f*scaler );
		break;
	}

	if (m_pWrapper)
	{
		m_pWrapper->m_pD3DDevice7->SetTransform( D3DTRANSFORMSTATE_WORLD, &m_MxWorld.m_Mx );
		m_pWrapper->m_pD3DDevice7->SetTransform( D3DTRANSFORMSTATE_VIEW, &m_MxView.m_Mx );
	}

	
	return;
}

void CNURBSSample::KeyUp(WPARAM wParam)
{		
	switch (wParam) 
	{
		//add code here to handle key releases, if you need them (as in remmed out example)
	case VK_UP:
		//OutputDebugString("The up arrow was released;");			
		break;
	}
	
	return;
}


void CNURBSSample::MouseLeftUp(WPARAM wParam, LPARAM lParam)
{	
	return;
}

void CNURBSSample::MouseLeftDown(WPARAM wParam, LPARAM lParam)
{		
	return;
}

void CNURBSSample::MouseRightUp(WPARAM wParam, LPARAM lParam)
{	
	return;
}

void CNURBSSample::MouseRightDown(WPARAM wParam, LPARAM lParam)
{		
	return;
}

void CNURBSSample::MouseMove(WPARAM wParam, LPARAM lParam)
{
	if ( wParam & MK_LBUTTON )	// Left button down plus mouse move == rotate
	{
		//we need a variable to modify our rotation speed with frame rate	
		float scaler = 1.0f;
		if(m_pWrapper) //we could get into this loop after the wrapper has been invalidates
		{
			scaler = 2.0f / max(m_pWrapper->m_dwRenderWidth, m_pWrapper->m_dwRenderHeight);  
		}

		//we need to compare the last position to the current position
		int x = LOWORD(lParam);
		int y = HIWORD(lParam);
		
		if (x - m_iMousePrevX)
		{
			m_MxView.Rotate( m_MxView.m_Mx._12, m_MxView.m_Mx._22, m_MxView.m_Mx._32, 3.14159f*scaler*(float)(x - m_iMousePrevX) );
		}
			
		if (y - m_iMousePrevY)
		{
			m_MxView.Rotate( m_MxView.m_Mx._11, m_MxView.m_Mx._21, m_MxView.m_Mx._31, 3.14159f*scaler*(float)(y - m_iMousePrevY) );
		}

		m_pWrapper->m_pD3DDevice7->SetTransform( D3DTRANSFORMSTATE_WORLD, &m_MxWorld.m_Mx );
		m_pWrapper->m_pD3DDevice7->SetTransform( D3DTRANSFORMSTATE_VIEW, &m_MxView.m_Mx );

	
		m_iMousePrevX = x;
		m_iMousePrevY = y;

	}
	else if ( wParam & MK_RBUTTON )	// Right button down plus mouse move == Zoom camera in/out
	{
		//we need a variable to modify our rotation speed with frame rate	
		float scaler = 1.0f;
		if(m_pWrapper) //we could get into this loop after the wrapper has been invalidates
		{
			scaler = 5.0f / max(m_pWrapper->m_dwRenderWidth, m_pWrapper->m_dwRenderHeight);  
		}

		//we need to compare the last position to the current position
		int x = LOWORD(lParam);
		int y = HIWORD(lParam);
		
		if (y - m_iMousePrevY)
		{
			DRGMatrix Temp(true);

			Temp.Translate( 0,0,scaler * (y - m_iMousePrevY) );
			m_MxView.PostMultiply( Temp );
		}

		m_pWrapper->m_pD3DDevice7->SetTransform( D3DTRANSFORMSTATE_WORLD, &m_MxWorld.m_Mx );
		m_pWrapper->m_pD3DDevice7->SetTransform( D3DTRANSFORMSTATE_VIEW, &m_MxView.m_Mx );

	
		m_iMousePrevX = x;
		m_iMousePrevY = y;

	}
	else
	{
		//need to update these, or the next time someone clicks, the delta is massive
		m_iMousePrevX = LOWORD(lParam);
		m_iMousePrevY = HIWORD(lParam);	
	}
	return;
}

