// NURBSSample.h - Created with DR&E AppWizard 1.0B8
// ------------------------------------------------------------------------------------
// Copyright  1999 Intel Corporation
// All Rights Reserved
// 
// Permission is granted to use, copy, distribute and prepare derivative works of this 
// software for any purpose and without fee, provided, that the above copyright notice
// and this statement appear in all copies.  Intel makes no representations about the
// suitability of this software for any purpose.  This software is provided "AS IS." 
//
// Intel specifically disclaims all warranties, express or implied, and all liability,
// including consequential and other indirect damages, for the use of this software, 
// including liability for infringement of any proprietary rights, and including the 
// warranties of merchantability and fitness for a particular purpose.  Intel does not
// assume any responsibility for any errors which may appear in this software nor any
// responsibility to update it.
// ------------------------------------------------------------------------------------
//
// PURPOSE:
//    
// NURBSSample.h: declaration of the NURBSSample class.
//
// ------------------------------------------------------------------------------------
//
// Author: Dean Macri - Intel Developer Relations Divison -- Tools and Technology Group
//
////////////////////////////////////////////////////////////////////////////////////////


#if !defined(AFX_DRGAPP_H__CFF24425_47D6_11D2_B1A5_00A0C90D2C1B__INCLUDED_)
#define AFX_DRGAPP_H__CFF24425_47D6_11D2_B1A5_00A0C90D2C1B__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#define	NUMSAMPLEBACKGROUNDVERTS	6


class CNURBSSample  
{
    CDRGWrapper *m_pWrapper;
	D3DTLVERTEX m_SampleBackgroundVerts[NUMSAMPLEBACKGROUNDVERTS];	// For the background plane
	bool	m_bDrawBackground;

	
	DRGMatrix m_MxWorld;
	DRGMatrix m_MxProjection;
	DRGMatrix m_MxView;

	
	CDRGTexture *m_pDefaultTexture;
	CDRGText *m_pStatText;

	int m_StatStringArray[4];

	CDRGMaterial	*m_pDefaultMaterial;

	CDRGObject *m_pSampleRootObj1, *m_pSampleRootObj2;

	CDRGNURBSSurface *m_pSampleNURBSSurface[9];
	CDRGNURBSSurface *m_pSampleNURBSSurface2;


	int  m_iMousePrevX;
	int  m_iMousePrevY;

	bool m_bWireframe;
	bool m_bUseTextures;
	bool m_bUseSSE;
	bool m_bOnePatch;

	int m_iTessellationLevel;

public:
    CNURBSSample();
    virtual ~CNURBSSample();
	
    virtual HRESULT InitWorld( CDRGWrapper *pWrapper );
	virtual HRESULT SetupDependantItems(void);
	virtual HRESULT DestroyWorld( void );

	virtual HRESULT UpdateWorld();
	virtual HRESULT RenderWorld( void );

	virtual HRESULT TargetChanged( void );

	void KeyDown(WPARAM wParam);
	void KeyUp(WPARAM wParam);

	void MouseLeftUp(WPARAM wParam, LPARAM lParam);
	void MouseLeftDown(WPARAM wParam, LPARAM lParam);
	void MouseRightUp(WPARAM wParam, LPARAM lParam);
	void MouseRightDown(WPARAM wParam, LPARAM lParam);
	void MouseMove(WPARAM wParam, LPARAM lParam);


private:

	void SetupSampleBackgroundVerts();

	
};

#endif // !defined(AFX_DRGAPP_H__CFF24425_47D6_11D2_B1A5_00A0C90D2C1B__INCLUDED_)
