// firetest.h - Created with DR&E AppWizard 1.0B8
// ------------------------------------------------------------------------------------
// Copyright  1999 Intel Corporation
// All Rights Reserved
// 
// Permission is granted to use, copy, distribute and prepare derivative works of this 
// software for any purpose and without fee, provided, that the above copyright notice
// and this statement appear in all copies.  Intel makes no representations about the
// suitability of this software for any purpose.  This software is provided "AS IS." 
//
// Intel specifically disclaims all warranties, express or implied, and all liability,
// including consequential and other indirect damages, for the use of this software, 
// including liability for infringement of any proprietary rights, and including the 
// warranties of merchantability and fitness for a particular purpose.  Intel does not
// assume any responsibility for any errors which may appear in this software nor any
// responsibility to update it.
// ------------------------------------------------------------------------------------
//
//  PURPOSE:
//    
// firetest.h: declaration of the firetest class.
// This class is the "blank" class created by the DRG 3D Appwizard, where you will put your stuff
//
// ------------------------------------------------------------------------------------
//
// Author: Kim Pallister - Intel Developer Relations & Engineering Group
//
////////////////////////////////////////////////////////////////////////////////////////


#if !defined(AFX_DRGAPP_H__CFF24425_47D6_11D2_B1A5_00A0C90D2C1B__INCLUDED_)
#define AFX_DRGAPP_H__CFF24425_47D6_11D2_B1A5_00A0C90D2C1B__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#define	NUMSAMPLEBACKGROUNDVERTS	6	//We'll just use two discrete triangles to render the backdrop

#define	TEXSIZE	256						//To keep things simple, I'll just use a 256x256 sample

#define DRAWSCENETOTEXTURE			0	//Toggles where we'll draw our spheres
#define DRAWSCENETOBACKBUFFER		1
#define DRAWSCENETOBOTH				2



class CFiretest  
{
    CDRGWrapper *m_pWrapper;
	D3DTLVERTEX m_SampleBackgroundVerts[NUMSAMPLEBACKGROUNDVERTS];	// For the background plane drawn to our actual backbuffer
	D3DTLVERTEX m_TextureBackgroundVerts[NUMSAMPLEBACKGROUNDVERTS];	// For the background plane drawn to our texture
	
	D3DTLVERTEX m_FireVerts[TEXSIZE];	// For the row of verts drawn along the bottom of the texture

	DRGMatrix m_MxWorld;
	DRGMatrix m_MxProjection;
	DRGMatrix m_MxView;

	
	CDRGTexture *m_pDefaultTexture;
	CDRGMaterial	*m_pDefaultMaterial;

	CDRGTexture *m_pFireTextureArray[3]; //3 texture pointers. Two we'll use, and one to swap.
	
	CDRGObject *m_pSampleRootObj;
	CDRGObjectSphere *m_pSampleSphereObj1;
	CDRGObject *m_pSampleDummyObj;
	CDRGObjectSphere *m_pSampleSphereObj2;
	
	int m_iSceneTarget;

	int  m_iMousePrevX;
	int  m_iMousePrevY;


public:
    CFiretest();
    virtual ~CFiretest();
	
    virtual HRESULT InitWorld( CDRGWrapper *pWrapper );
	virtual HRESULT SetupDependantItems(void);
	virtual HRESULT DestroyWorld( void );

	virtual HRESULT UpdateWorld();
	virtual HRESULT RenderWorld( void );

	virtual HRESULT TargetChanged( void );

	void KeyDown(WPARAM wParam);
	void KeyUp(WPARAM wParam);

	void MouseLeftUp(WPARAM wParam, LPARAM lParam);
	void MouseLeftDown(WPARAM wParam, LPARAM lParam);
	void MouseRightUp(WPARAM wParam, LPARAM lParam);
	void MouseRightDown(WPARAM wParam, LPARAM lParam);
	void MouseMove(WPARAM wParam, LPARAM lParam);


private:

	void SetupSampleBackgroundVerts();
	void SetupTextureBackgroundVerts(float h,float v);
	
};

#endif // !defined(AFX_DRGAPP_H__CFF24425_47D6_11D2_B1A5_00A0C90D2C1B__INCLUDED_)
