// ShadowTex.h - Created with DR&E AppWizard 1.0B8
// ------------------------------------------------------------------------------------
// Copyright  1999 Intel Corporation
// All Rights Reserved
// 
// Permission is granted to use, copy, distribute and prepare derivative works of this 
// software for any purpose and without fee, provided, that the above copyright notice
// and this statement appear in all copies.  Intel makes no representations about the
// suitability of this software for any purpose.  This software is provided "AS IS." 
//
// Intel specifically disclaims all warranties, express or implied, and all liability,
// including consequential and other indirect damages, for the use of this software, 
// including liability for infringement of any proprietary rights, and including the 
// warranties of merchantability and fitness for a particular purpose.  Intel does not
// assume any responsibility for any errors which may appear in this software nor any
// responsibility to update it.
// ------------------------------------------------------------------------------------
//
//  PURPOSE:
//    
// ShadowTex.h: declaration of the ShadowTex class.
// This class is the "blank" class created by the DRG 3D Appwizard, where you will put your stuff
//
// ------------------------------------------------------------------------------------
//
// Author: Kim Pallister - Intel Developer Relations & Engineering Group
//
////////////////////////////////////////////////////////////////////////////////////////


#if !defined(AFX_DRGAPP_H__CFF24425_47D6_11D2_B1A5_00A0C90D2C1B__INCLUDED_)
#define AFX_DRGAPP_H__CFF24425_47D6_11D2_B1A5_00A0C90D2C1B__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

class CShadowTex  
{

	D3DTLVERTEX m_ShadowRectVerts[6];	// For the background plane

	bool	m_bShowShadowRect;

    CDRGWrapper *m_pWrapper;

	
	DRGMatrix m_MxWorld;
	DRGMatrix m_MxProjection;
	DRGMatrix m_MxView;

	DRGMatrix m_MxLightProjection;
	DRGMatrix m_MxLightView;

	
	CDRGTexture *m_pDefaultTexture;

	CDRGTexture *m_pTigerTexture;
	CDRGTexture *m_pFloorTexture;
	CDRGTexture *m_pShadowTexture;
	
	CDRGMaterial	*m_pDefaultMaterial;
	CDRGMaterial	*m_pTigerMaterial;
	CDRGMaterial	*m_pFloorMaterial;


	CDRGObject *m_pRootObj;
	CDRGObjectPlane *m_pFloorPlaneArray[9]; //we're making our array out of 9 panels to test out our transforms
	
	CDRGObjectCube *m_pCubeObj;
	CDRGObject *m_pTigerObj;
	CDRGObject *m_pLightDummyObj;
	CDRGObjectSphere *m_pLightObj;
	CDRGObject		 *m_pBallDummyObj;	
	CDRGObjectSphere *m_pBallObj1;
	CDRGObjectSphere *m_pBallObj2;

	D3DLIGHT7 m_DefaultLight;
	
	int  m_iMousePrevX;
	int  m_iMousePrevY;


public:
    CShadowTex();
    virtual ~CShadowTex();
	
    virtual HRESULT InitWorld( CDRGWrapper *pWrapper );
	virtual HRESULT InitShadowTexture( int size );
	
	virtual HRESULT SetupDependantItems(void);
	virtual HRESULT DestroyWorld( void );

	virtual HRESULT UpdateWorld();
	virtual HRESULT RenderWorld( void );

	virtual HRESULT TargetChanged( void );

	void KeyDown(WPARAM wParam);
	void KeyUp(WPARAM wParam);

	void MouseLeftUp(WPARAM wParam, LPARAM lParam);
	void MouseLeftDown(WPARAM wParam, LPARAM lParam);
	void MouseRightUp(WPARAM wParam, LPARAM lParam);
	void MouseRightDown(WPARAM wParam, LPARAM lParam);
	void MouseMove(WPARAM wParam, LPARAM lParam);


private:

	void SetupShadowRect(float h,float v);
	HRESULT UpdateLightFrustum();
	
};

#endif // !defined(AFX_DRGAPP_H__CFF24425_47D6_11D2_B1A5_00A0C90D2C1B__INCLUDED_)
