//-----------------------------------------------------------------------------
// BiCubicPatch.h
//
// Started 06/28/2000
//
// Shrike Framework -  Rob Wyatt
//-----------------------------------------------------------------------------

#if !defined(BICUBICPATCH_H_INCLUDED)
#define BICUBICPATCH_H_INCLUDED

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "Tessellate2D.h"

//-----------------------------------------------------------------------------
class CubicPatch : public Tessellate2D
{
public:

    //-----------------------------------------------------------------------------
    CubicPatch
    (
	    Vector3& c00, Vector3& c01, Vector3& c02, Vector3& c03, 
	    Vector3& c10, Vector3& c11, Vector3& c12, Vector3& c13, 
	    Vector3& c20, Vector3& c21, Vector3& c22, Vector3& c23, 
        Vector3& c30, Vector3& c31, Vector3& c32, Vector3& c33, 
        uint32  tess_u,
        uint32  tess_v
    );

    //-----------------------------------------------------------------------------
    // Virtual destructor
    virtual ~CubicPatch
    (
    );

    //-----------------------------------------------------------------------------
    // This is the function that we have to implement. This function takes the U,V
    // passed in (0.0 to 1.0) and generates a point on the surface of the patch
    virtual Vector3 GeneratePosition
    (
        float   u,
        float   v
    );

private:

    Vector3 m_Control[4][4];            // Array of control points
};

#endif
