//-----------------------------------------------------------------------------
// BiQuadraticPatch.h
//
// Started 06/24/2000
//
// Shrike Framework -  Rob Wyatt
//-----------------------------------------------------------------------------

#if !defined(BIQUADRATICPATCH_H_INCLUDED)
#define BIQUADRATICPATCH_H_INCLUDED

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "Tessellate2D.h"

//-----------------------------------------------------------------------------
class QuadraticPatch : public Tessellate2D
{
public:

    //-----------------------------------------------------------------------------
    QuadraticPatch
    (
	    Vector3& c00, Vector3& c01, Vector3& c02, 
	    Vector3& c10, Vector3& c11, Vector3& c12, 
	    Vector3& c20, Vector3& c21, Vector3& c22,
        uint32  tess_u,
        uint32  tess_v
    );

    //-----------------------------------------------------------------------------
    // Virtual destructor
    virtual ~QuadraticPatch
    (
    );

    //-----------------------------------------------------------------------------
    // This is the function that we have to implement. This function takes the U,V
    // passed in (0.0 to 1.0) and generates a point on the surface of the patch
    virtual Vector3 GeneratePosition
    (
        float   u,
        float   v
    );

private:

    Vector3 m_Control[3][3];            // Array of control points
};

#endif
