//-----------------------------------------------------------------------------
// Colors.h
//
// Started 06/21/2000
//
// Shrike Framework -  Rob Wyatt 
//-----------------------------------------------------------------------------
#if !defined(COLORS_H_INCLUDED)
#define COLORS_H_INCLUDED

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "D3d.h"
#include "Debug.h"

//----------------------------------------------------------------------------
class RGBColor : public D3DCOLORVALUE
{
public:
    //----------------------------------------------------------------------------
    RGBColor
    (
    )
    //--------------------------------------
    {
    }

    //----------------------------------------------------------------------------
    // Construct from a colour and assume alpha to be 1.0f
    RGBColor
    (
        float red,
        float green,
        float blue
    )
    //--------------------------------------
    {
        r = red;
        g = green;
        b = blue;
        a = 1.0f;
    }

    //----------------------------------------------------------------------------
    RGBColor
    (
        float red,
        float green,
        float blue,
        float alpha
    )
    //--------------------------------------
    {
        r = red;
        g = green;
        b = blue;
        a = alpha;
    }

    //----------------------------------------------------------------------------
    operator D3DCOLOR
    (
    ) const
    //--------------------------------------
    {
        // When we convert a color to a D3DCOLOR all the color values must be withib
        // 0.0 to 1.0 otherwise we will create a bad color.
        Assert( (r>=0.0f) && (r<=1.0f) );
        Assert( (g>=0.0f) && (g<=1.0f) );
        Assert( (b>=0.0f) && (b<=1.0f) );
        Assert( (a>=0.0f) && (a<=1.0f) );

        return  (DWORD)((((DWORD)(a * 255.0f))<<24) | (((DWORD)(r * 255.0f))<<16) |
                (((DWORD)(g * 255.0f))<<8) | ((DWORD)(b * 255.0f)));
    }
};


#endif

