//-----------------------------------------------------------------------------
// Debug.h
//
// Started 06/09/2000
//
// Shrike Framework -  Rob Wyatt
//-----------------------------------------------------------------------------
#if !defined(DEBUG_H_INCLUDED)
#define DEBUG_H_INCLUDED

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include <CrtDbg.h>         //Windows debug header
#include "BuildVer.h"

#if defined(_DEBUG)
//
// We need to include debugging info
//

#define Assert(x)  _ASSERT(x)

#define DBGSTR(str) dprintf(str)

void dprintf(char* str,...);

#else

//
// We need to remove debugging info so define functions inline as empty functions so
// the compiler will remove them, also define macros as empty.
//

#define Assert(x)

#define DBGSTR(str)

__forceinline void dprintf(char* str,...)
{
}

#endif  //defined(_DEBUG)


// Include the correct library
#if defined(_DEBUG)
#pragma comment(lib, "DebugD.lib")
#else
#pragma comment(lib, "DebugR.lib")
#endif


#endif

