//-----------------------------------------------------------------------------
// Sphere.h
//
// Started 06/28/2000
//
// Shrike Framework -  Rob Wyatt
//-----------------------------------------------------------------------------

#if !defined(SPHERE_H_INCLUDED)
#define SPHERE_H_INCLUDED

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "Tessellate2D.h"

//-----------------------------------------------------------------------------
class Sphere : public Tessellate2D
{
public:

    //-----------------------------------------------------------------------------
    Sphere
    (
		float	radius,
        uint32  tess_u,
        uint32  tess_v
    );

    //-----------------------------------------------------------------------------
    // This is the function that we have to implement. This function takes the U,V
    // passed in (0.0 to 1.0) and generates a point on the surface of the sphere
    virtual Vector3 GeneratePosition
    (
        float   u,
        float   v
    );

    //-----------------------------------------------------------------------------
    // It is easy to generate an accurate analytical normal for a sphere as it is
    // a point on a unit sphere. The default implementation is bad because of the
    // degenerate points at the poles.
    virtual Vector3 GenerateNormal
    (
        float   u,
        float   v
    );

private:
    float   m_Radius;
};

#endif
