//-----------------------------------------------------------------------------
// Timer.h
//
// Started 06/16/2000
//
// Shrike Framework -  Rob Wyatt
//-----------------------------------------------------------------------------
#if !defined(TIMER_H_INCLUDED)
#define TIMER_H_INCLUDED

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


#include "Common.h"

//-----------------------------------------------------------------------------
// A sub millisecond timer class.
class Timer
{
public:
    //-----------------------------------------------------------------------------
    Timer
    (
    );

    //-----------------------------------------------------------------------------
    // Return an accurate time from the time this class was created or last reset
    float GetElapsed
    (
    )
    //--------------------------------------
    {
        int64   time;
        int64   elapsed;
        QueryPerformanceCounter((LARGE_INTEGER*)&time);
        elapsed = (time - m_TimeStart)-m_PauseAdjust;

        return (float)( ((double)elapsed)/m_TimerFrequency );
    }

    //-----------------------------------------------------------------------------
    // Resets the timer and pause state to unpaused
    void Reset
    (
    )
    //--------------------------------------
    {
        // Get the new initial time
        QueryPerformanceCounter((LARGE_INTEGER*)&m_TimeStart);
        m_PauseAdjust = 0;
    }

    //-----------------------------------------------------------------------------
    // Pause or unpause a timer, useful when an app loses its focus
    void Pause
    (
        bool    request_pause
    );

private:
    int64           m_TimeStart;
    int64           m_PauseAdjust;
    static double   m_TimerFrequency;
};




// Include the correct library
#if defined(_DEBUG)
#pragma comment(lib, "SystemD.lib")
#else
#pragma comment(lib, "systemR.lib")
#endif

#endif

