//-----------------------------------------------------------------------------
// Torus.h
//
// Started 06/24/2000
//
// Shrike Framework -  Rob Wyatt
//-----------------------------------------------------------------------------

#if !defined(TORUS_H_INCLUDED)
#define TORUS_H_INCLUDED

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "Tessellate2D.h"

//-----------------------------------------------------------------------------
class Torus : public Tessellate2D
{
public:

    //-----------------------------------------------------------------------------
    Torus
    (
		float	min_radius,
		float	max_radius,
        uint32  tess_u,
        uint32  tess_v
    );

    //-----------------------------------------------------------------------------
    // Virtual destructor
    virtual ~Torus
    (
    );

    //-----------------------------------------------------------------------------
    // This is the function that we have to implement. This function takes the U,V
    // passed in (0.0 to 1.0) and generates a point on the surface of the patch
    virtual Vector3 GeneratePosition
    (
        float   u,
        float   v
    );

    //-----------------------------------------------------------------------------
    // It is easy to generate an accurate analytical normal for a torus. The default
    // implementation works well if the tessellation is high but this method works
    // well with low tessellation.
    virtual Vector3 GenerateNormal
    (
        float   u,
        float   v
    );

private:
    float   m_MinRadius;
    float   m_MaxRadius;
};

#endif
