//-----------------------------------------------------------------------------
// Euler.cpp
//
// Started 06/25/2000
//
// Shrike Framework -  Rob Wyatt 
//-----------------------------------------------------------------------------
#include "Euler.h"
#include "ShrikeMath.h"

//------------------------------------------------------------------------------
// Standard macro to reroute new allocations to the debug allocator
#if defined(_DEBUG)
#define new DEBUG_NEW
#define DEBUG_NEW new(_NORMAL_BLOCK,THIS_FILE,__LINE__)
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


//----------------------------------------------------------------------------
EulerAngle::operator Matrix4
(
) const
//--------------------------------------
{
    SinCosPair SinCos1;
    SinCosPair SinCos2;
    SinCosPair SinCos3;

    Matrix4 res = Matrix4::Identity;

    switch (m_MultiplyOrder)
    {
    case EULER_X:
        SinCos(m_FirstAngle,SinCos1);
        res._22 =  SinCos1.c;
        res._23 =  SinCos1.s;
        res._32 = -res._23;
        res._33 =  res._22;
        break;

    case EULER_Y:
        SinCos(m_FirstAngle,SinCos1);
        res._11 =  SinCos1.c;
        res._13 = -SinCos1.s;
        res._31 = -res._13;
        res._33 =  res._11;
        break;

    case EULER_Z:
        SinCos(m_FirstAngle,SinCos1);
        res._11 =  SinCos1.c;
        res._12 =  SinCos1.s;
        res._21 = -res._12;
        res._22 =  res._11;
        break;

    case EULER_XYZ:
        SinCos(m_FirstAngle,SinCos1);
        SinCos(m_SecondAngle,SinCos2);
        SinCos(m_ThirdAngle,SinCos3);
        res._11 = SinCos2.c*SinCos3.c; 
        res._12 = SinCos2.c*SinCos3.s; 
        res._13 = -SinCos2.s;
        res._21 = (SinCos1.s*SinCos2.s*SinCos3.c)-(SinCos1.c*SinCos3.s); 
        res._22 = (SinCos1.s*SinCos2.s*SinCos3.s)+(SinCos1.c*SinCos3.c); 
        res._23 = SinCos1.s*SinCos2.c;
        res._31 = (SinCos1.c*SinCos2.s*SinCos3.c)+(SinCos1.s*SinCos3.s); 
        res._32 = (SinCos1.s*SinCos1.c*SinCos3.s)-(SinCos1.s*SinCos3.c); 
        res._33 = SinCos1.c*SinCos2.c;
        break;

    default:
        Assert(0);
    }

    return res;
}
