
/*
    TEDDY - General graphics application library
    Copyright (C) 1999, 2000  Timo Suoranta

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    Timo Suoranta
    tksuoran@cc.helsinki.fi
*/


#include "FrontCamera.h"
#include "PhysicalComponents/LayoutConstraint.h"
#include "PhysicalComponents/WindowFrame.h"
#include "Graphics/View.h"
using namespace Graphics;


//!  Constructor
FrontCamera::FrontCamera( Camera *camera ):Projection(camera){
	constraint = new LayoutConstraint();  //  FIX?

#ifdef USE_WINDOW_SYSTEM
	constraint->local_x_fill_pixels    = SCREEN_X-30;  //  FIX
	constraint->local_y_fill_pixels    = SCREEN_Y-240;
	constraint->parent_x_offset_pixels =   20;
	constraint->parent_y_offset_pixels =   90;

	this->insert(
		new WindowFrame( "Heads Up Display" )
	);
#else
	constraint->parent_x_fill_relative = 1.0;
	constraint->parent_y_fill_relative = 1.0;
#endif
}


//!  Destructor
FrontCamera::~FrontCamera(){
	//  FIX
}


