
/*
    TEDDY - General graphics application library
    Copyright (C) 1999, 2000  Timo Suoranta

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    Timo Suoranta
    tksuoran@cc.helsinki.fi
*/


/*!
	\class   FrontCamera
	\ingroup g_testing_environment
	\author  Timo Suoranta
	\brief   Main 3D display for testing environment
	\warning The perspective interface is not yet in use/designed
	\date    2000
*/


#ifndef TEDDY_TEST_FRONT_CAMERA_H
#define TEDDY_TEST_FRONT_CAMERA_H


#include "Scenes/Camera.h"
#include "PhysicalComponents/Projection.h"


class FrontCamera : public Projection {
public:
	FrontCamera( Camera *camera );
	virtual ~FrontCamera();
};


#endif  //  TEDDY_TEST_FRONT_CAMERA_H

