
/*
    TEDDY - General graphics application library
    Copyright (C) 1999, 2000  Timo Suoranta

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    Timo Suoranta
    tksuoran@cc.helsinki.fi
*/


/*!
	\class   RenderContext
	\ingroup g_graphics
	\author  Timo Suoranta
	\brief   Abstract base class / Interface for render contexts
	\date    2000

	Each draw and update operation of Renderable need RenderContext
	which actually performs the rendering operations; Renderable
	maintains drawing instructions for RenderingContext.
*/


#ifndef TEDDY_GRAPHICS_RENDER_CONTEXT_H
#define TEDDY_GRAPHICS_RENDER_CONTEXT_H


#include "Graphics/OpenGL.h"
#include <list>
using namespace std;


namespace Graphics {
			   

class RenderContext {
public:
	RenderContext();
	virtual ~RenderContext(){}

/*	void            setPriority( int priority );
	int             getPriority() const;
	RenderContext  *getParent  ();
	RenderContext  *getRoot    ();*/
};


};  //  namespace Graphics


#endif  //  TEDDY_GRAPHICS_RENDER_CONTEXT_H

