
/*
    TEDDY - General graphics application library
    Copyright (C) 1999, 2000  Timo Suoranta

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    Timo Suoranta
    tksuoran@cc.helsinki.fi
*/


/*!
	\class   Hud
	\ingroup g_testing_environment
	\author  Timo Suoranta
	\date    2000

	Heads Up Display
*/


#ifndef TEDDY_TEST_HUD_H
#define TEDDY_TEST_HUD_H


#include <Models/ModelInstance.h>
#include <Physics/System.h>
#include <PhysicalComponents/Area.h>
#include <Scenes/Camera.h>
using namespace Models;
using namespace Physics;
using namespace PhysicalComponents;
using namespace Scenes;


class Hud : public Area {
public:
	Hud( Camera *cam, System *sys );

	void setTarget( ModelInstance *target );

	virtual void drawSelf();

protected:
	Camera        *camera;
	System        *system;
	ModelInstance *target;
};


#endif  //  TEDDY_TEST_HUD_H

