
/*
    TEDDY - General graphics application library
    Copyright (C) 1999, 2000  Timo Suoranta

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    Timo Suoranta
    tksuoran@cc.helsinki.fi
*/


/*!
	\class   LWClip
	\ingroup g_imports
	\author  Timo Suoranta
	\brief   Parser for LightWave object file envelope subchunks
	\warning Very incomplete
	\bug     Destructors missing?
	\date    2000

	Only for Lighwave files from version 6.0 and up
*/


#ifndef TEDDY_IMPORTS_LW_CLIP_H
#define TEDDY_IMPORTS_LW_CLIP_H


#include "Imports/LWFile.h"


namespace Imports {


class LWClip {
public:
	LWClip( LWFile *f );

	void processClip();

protected:
	void readStillImage_FNAM0();
	void readImageSequence_U1_U1_I2_I2_FNAM0_S0();
	void readAnimation_FNAM0_S0_U2_d();
	void readStillColorCycle_I2_I2_FNAM0();
	void readContrast_FP4_VX();
	void readBrightness_FP4_VX();
	void readSaturation_FP4_VX();
	void readHue_FP4_VX();
	void readGamma_F4_VX();
	void readNegative_U2();
	void readImageFilter_S0_U2_d();
	void readPixelFilter_S0_U2_d();

	LWFile *f;
	ID4     clip_type;
	U4      clip_length;
};


};  //  namespace Imports


#endif  //  TEDDY_IMPORTS_LW_CLIP_H

