
/*
    TEDDY - General graphics application library
    Copyright (C) 1999, 2000  Timo Suoranta

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    Timo Suoranta
    tksuoran@cc.helsinki.fi
*/


#include "Imports/LWSurfaceBlok.h"
#include <iostream>
using namespace std;


namespace Imports {


LWSurfaceBlok::LWSurfaceBlok( LWFile *f ){
	this->f = f;
}


void LWSurfaceBlok::processBlok(){
	blok_type    = f->read_ID4();
	ID4 blok_ordinal = f->read_ID4();
//	blok_length  = f->read_U2();
//	f->pushDomain( blok_length );

/*	did( blok_type );
	cout << " blok of ord ";
	did( blok_ordinal );
	cout << endl;*/
	while( f->domainLeft() > 0 ){
		ID4 subchunk = f->read_ID4();
		U2  length   = f->read_U2();
/*		did( subchunk );
		cout << endl;
		cout.flush();*/
		f->pushDomain( length );
		switch( subchunk ){
			//  Header
			case ID_CHAN: {
				ID4 chan = f->read_ID4();
/*				cout << "Channel ";
				did( chan );
				cout << endl;
				cout.flush();*/
				break;
			}
			case ID_ENAB: break;
			case ID_OPAC: break;
			default:
				switch( blok_type ){
					case ID_IMAP: break;
					case ID_PROC: break;
					case ID_GRAD: break;
					case ID_SHDR: break;
					default:
						break;
				}
				break;			
		}
		f->popDomain( true );
	}
}


};  //  namespace Imports

