
/*!
	\class   Light
	\ingroup g_lights
	\author  Timo Suoranta
	\brief   Lightsource baseclass
	\warning Very incomplete
	\bug     Poor id and enable/disable management
	\bug     Should be child of ModelInstance?
	\bug     Destructors missing?
	\date    1999, 2000

	Lights are used to lit objects in Scene. At the moment
	this class implements a simple OpenGL light wrapper
	with minimum featurs.
*/


#ifndef TEDDY_FIX_LIGHT_H
#define TEDDY_FIX_LIGHT_H


#include "ModelInstance.h"
#include "Color.h"
#include "Vector.h"
#include <string>
using namespace std;
using namespace Models;


class Light : public ModelInstance {
public:
	Light( const string &name );

	void          setAmbient ( const Color &a );
	void          setDiffuse ( const Color &d );
	void          setSpecular( const Color &s );
	void          setPosition( const Vector &p );
	virtual void  translate  ( const double x, const double y, const double z );
	virtual void  applyLight ();
	const string &getName    ();

protected:
	string name;
	int    id;
	Color  ambient;
	Color  diffuse;
	Color  specular;
	Vector position;
		
	static GLenum light_id    [8];  //  FIX (query number of available lights from OpenGL)
	static int    light_status[8];	
};


#endif  //  TEDDY_FIX_LIGHT_H


