
/*
    TEDDY - General graphics application library
    Copyright (C) 1999, 2000  Timo Suoranta

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    Timo Suoranta
    tksuoran@cc.helsinki.fi
*/


/*!
	\class   MouseListener
	\ingroup g_input
	\author  Timo Suoranta
	\date    2000

	Each Physical component wishing to receive input from mouse
	must implement the KeyListener interface. Input will call
	mouseKey() and mouseMotion() methods for those Areas that
	implement the MouseListener interface and have registered
	themselved with the registerArea() method.

	Later the MouseListener interface might be split to several
	interfaces, some with drag recognition support for example.
*/


#ifndef TEDDY_INPUTS_MOUSE_LISTENER_H
#define TEDDY_INPUTS_MOUSE_LISTENER_H


namespace Inputs {


class MouseListener {
public:
	virtual void focusActive( const bool active ){};
	virtual void mouseKey   ( int button, int state, int x, int y ) = 0;
	virtual void mouseMotion( int x, int y ) = 0;
};


};  //  namespace Inputs


#endif  //  TEDDY_INPUTS_MOUSE_LISTENER_H


