
/*!
	\file
	\class   Base
	\ingroup g_kamin
	\author  Samuel Kamin, Timothy Budd, Timo Suoranta
	\date    2000
*/


#ifndef TEDDY_KAMIN_BASE_H
#define TEDDY_KAMIN_BASE_H


#include "Kamin/Environment.h"
#include "Kamin/Expr.h"
#include "Kamin/Expression.h"
#include "Kamin/List.h"


namespace Kamin {


class ReaderClass;


class Base {
public:
	Base(){}

	ReaderClass *reader;
	Env          globalEnvironment;  //!<  Global symbols
	Env          valueOps;           //!<  Built-in operations
	Env          commands;           //!<  Top level commands
	List         emptyList;
	Expr         True;
	Expr         False;

	virtual void parse( char *line ) = 0;
};


};  //  namespace Kamin


#endif  //  TEDDY_KAMIN_BASE_H

