
/*!
	\file
	\class   BinaryFunction
	\ingroup g_kamin
	\brief   Binary functions take two arguments
	\author  Samuel Kamin, Timothy Budd, Timo Suoranta
	\date    2000
*/


#ifndef TEDDY_KAMIN_BINARY_FUNCTION_H
#define TEDDY_KAMIN_BINARY_FUNCTION_H


#include "Kamin/Function.h"


namespace Kamin {


class BinaryFunction : public Function {
public:
	BinaryFunction(){
		fun = 0;
	}

	BinaryFunction( void (*afun)(Expr &, Expression *, Expression *) ){
		fun = afun;
	}

	virtual void apply        ( Expr &target, ListNode *args, Environment *rho, Base *b );
	virtual void applyWithArgs( Expr &target, ListNode *args, Environment *rho, Base *b );

private:
	void (*fun)(Expr &, Expression *, Expression *);
};


};  //  namespace Kamin


#endif  //  TEDDY_KAMIN_BINARY_FUNCTION_H

