
/*!
	\file
	\class   BooleanBinaryFunction
	\ingroup g_kamin
	\brief   Boolean Binary Functions
	\author  Samuel Kamin, Timothy Budd, Timo Suoranta
	\date    2000
*/


#ifndef TEDDY_KAMIN_BOOLEAN_BINARY_FUNCTION_H
#define TEDDY_KAMIN_BOOLEAN_BINARY_FUNCTION_H


#include "Kamin/BinaryFunction.h"


namespace Kamin {


class BooleanBinaryFunction : public BinaryFunction {
public:
	BooleanBinaryFunction( int (*thefun)(int, int) ){
		fun = thefun;
	}
	virtual void applyWithArgs( Expr &target, ListNode *args, Environment *rho, Base *b );

private:
	int (*fun)(int, int);
};


};  //  namespace Kamin


#endif  //  TEDDY_KAMIN_BOOLEAN_BINARY_FUNCTION_H

