
#include "Kamin/DefineStatement.h"
#include "Kamin/UserFunction.h"
#include "Kamin/Symbol.h"
#include "Kamin/Lisp.h"


namespace Kamin {


void DefineStatement::apply( Expr &target, ListNode *args, Environment *rho, Base *b ){
	if( args->length() != 3 ){
		target = error( "define requires three arguments" );
		return;
	}

	Symbol *name = args->at(0)->isSymbol();
	if( !name ){
		target = error( "define missing name" );
		return;
	}

	ListNode *argNames = args->at(1)->isList();
	if( !argNames ){
		target = error( "define missing arg names" );
		return;
	}

	rho->add(
		name,
		new UserFunction( argNames, args->at(2), rho )
	);

	// yield as value the name of the function
	target = name;
};


};  //  namespace Kamin

