
#ifndef TEDDY_KAMIN_ENVIRONMENT_H
#define TEDDY_KAMIN_ENVIRONMENT_H


#include "Kamin/Function.h"
#include "Kamin/Expression.h"
#include "Kamin/Expr.h"
#include "Kamin/List.h"


namespace Kamin {


/*!
	\class   Env
	\ingroup g_kamin
	\author  Samuel Kamin, Timothy Budd, Timo Suoranta
	\date    2000

	Env is a shadow to Expr to perform memory management
*/
class Env : public Expr {
public:
	operator Environment*();
	void operator=( Environment *r );
};

//	forward declarations
class Symbol;

/*!
	\class   Environment
	\ingroup g_kamin
	\brief   An environment is built out of two parallel lists
	\author  Samuel Kamin, Timothy Budd, Timo Suoranta
	\date    2000
*/
class Environment : public Expression {
private:
	List theNames;
	List theValues;
	Env  theLink;

public:
	Environment( ListNode *names, ListNode *values, Environment *link );

	// overridden methods
	virtual void         free();
	virtual Environment *isEnvironment();

	// new methods
	Expression *lookup( Symbol *sym );
	void        add   ( Symbol *s, Expression *v );
	void        set   ( Symbol *sym, Expression *value );
};


//
//	now define the methods for class Env
//
inline Env::operator Environment * (){
	return val()?val()->isEnvironment():0;
}

inline void Env::operator = (Environment * r){
	Expr::operator = (r);
}


};  //  namespace Kamin


#endif  //  TEDDY_KAMIN_ENVIRONMENT_H

