
#include "Kamin/Expr.h"
#include "Kamin/Expression.h"
#include "Kamin/Base.h"


namespace Kamin {


Expr::Expr( Expression *val ){
	value   = val;
	if( val ){
		value->referenceCount++;
	}
}


void Expr::operator=( Expression *newvalue ){
	// increment right hand side of assignment
	if( newvalue ){
		newvalue->referenceCount++;
	}

	// decrement left hand side of assignment
	if( value ){
		value->referenceCount--;
		if( value->referenceCount == 0 ){
			value->free();
			delete value;
		}
	}

	// then do the assignment
	value = newvalue;
}


void Expr::evalAndPrint( Environment *valueops, Environment *rho, Base *b ){
	Expr target = 0;

	//  If we have a valid expression, evaluate it
	if( value ){
		value->eval( target, valueops, rho, b );
	}

	//  Now if we have an expression, print it out
	if( target() ){
		target()->print();
	}
	
	//  Force memory management
	target = 0;
}


#if 0
void Expr::print(){
	if( value ){
		value->print();
	}
	printf("\n");
}
#endif


};  //  namespace Kamin

