
#include "Kamin/Expression.h"
#include "Kamin/Expr.h"
#include <stdio.h>


namespace Kamin {


//
//	Expression - internal representation for expressions
//
Expression::Expression(){
	referenceCount = 0;
}


void Expression::free(){
	//  Do nothing
}


void Expression::eval( Expr &target, Environment *valueops, Environment *rho, Base *b ){
	//  Default is to do nothing
	target = this;
}


void Expression::print(){
	fprintf( stderr, "in expression::print - should be subclassed\n" );
}


//  Conversions

Expression        *Expression::touch         () { return this; }
IntegerExpression *Expression::isInteger     () { return 0; }
Symbol            *Expression::isSymbol      () { return 0; }
ListNode          *Expression::isList        () { return 0; }
Environment       *Expression::isEnvironment () { return 0; }
Function          *Expression::isFunction    () { return 0; }
APLValue          *Expression::isAPLValue    () { return 0; }
Method            *Expression::isMethod      () { return 0; }
Environment       *Expression::isCluster     () { return 0; }
PrologValue       *Expression::isPrologValue () { return 0; }
Continuation      *Expression::isContinuation() { return 0; }


Expression *error( char *a, char *b ){
	fprintf( stderr,"Error: %s%s\n", a, b );
	return 0;
}


};  //  namespace Kamin

