
/*!
	\file
	\class   Expression
	\ingroup g_kamin
	\author  Samuel Kamin, Timothy Budd, Timo Suoranta
	\date    2000
*/


#ifndef TEDDY_KAMIN_EXPRESSION_H
#define TEDDY_KAMIN_EXPRESSION_H


namespace Kamin {


//	forward references
class Expr;
class Environment;
class IntegerExpression;
class Symbol;
class ListNode;
class Function;
class Environment;
class APLValue;
class Method;
class PrologValue;
class Continuation;

class Base;


class Expression {
public:
	Expression();

	virtual void free();

	// basic object protocol
	virtual void eval ( Expr &target, Environment *valueops, Environment *rho, Base *b );
	virtual void print();

	// conversion tests
	virtual Expression        *touch();
	virtual IntegerExpression *isInteger();
	virtual Symbol            *isSymbol();
	virtual Function          *isFunction();
	virtual ListNode          *isList();
	virtual Environment       *isEnvironment();
	virtual APLValue          *isAPLValue();
	virtual Method            *isMethod();
	virtual Environment       *isCluster();
	virtual PrologValue       *isPrologValue();
	virtual Continuation      *isContinuation();

private:
	friend class Expr;
	int referenceCount;
};


extern Expression *error( char *, char *x = 0 );


};  //  namespace Kamin


#endif  //
