
#include "Kamin/Environment.h"
#include "Kamin/Function.h"
#include "Kamin/List.h"
#include "Kamin/Base.h"
#include <stdio.h>
#include "ui.h"  //  FIX


namespace Kamin {


Function *Function::isFunction(){
	return this;
}

void Function::print(){
	*console << "<closure>";
	printf( "<closure>" );
}

int Function::isClosure(){
	return 0;
}

// default behavior for function applications is to evaluate
// arguments

static ListNode *evalArgs( ListNode *args, Environment *rho, Base *b ){
	if( args->isNil() ){
		return args;
	}

	Expr        newhead;
	Expression *first = args->head();
	first->eval( newhead, b->valueOps, rho, b );
	return new ListNode(
		newhead(),
		evalArgs( args->tail(), rho, b )
	);
	newhead = 0; 	//  Force garbage collection
}

void Function::apply( Expr &target, ListNode *args, Environment *rho, Base *b ){
	List newargs;

	newargs.operator=( evalArgs(args, rho, b) );
	applyWithArgs( target, newargs, rho, b );
	newargs = 0;	//  Force garbage collection
}

void Function::applyWithArgs( Expr &target, ListNode *args, Environment *rho, Base *b ){
	target = error( "in function::applywithargs, should be overridden" );
}


};  //  namespace Kamin

