
/*!
	\file
	\class   Function
	\ingroup g_kamin
	\brief   Function base class
	\author  Samuel Kamin, Timothy Budd, Timo Suoranta
	\date    2000
*/


#ifndef TEDDY_KAMIN_FUNCTION_H
#define TEDDY_KAMIN_FUNCTION_H


#include "Kamin/Expression.h"
#include "Kamin/Expr.h"
#include "Kamin/ListNode.h"
#include "Kamin/Environment.h"


namespace Kamin {


class Function : public Expression {
public:
	virtual Function *isFunction();

	virtual void apply        ( Expr &target, ListNode *args, Environment *rho, Base *b );
	virtual void applyWithArgs( Expr &target, ListNode *args, Environment *rho, Base *b );
	virtual void print        ();

	// isClosure is recognized only by functions
	virtual int  isClosure();
};


};  //  namespace Kamin


#endif  //  TEDDY_KAMIN_FUNCTION_H

