
#include "Kamin/IfStatement.h"
#include "Kamin/Scheme.h"
#include "Kamin/Base.h"


namespace Kamin {


void IfStatement::apply( Expr &target, ListNode *args, Environment *rho, Base *b ){
	if( args->length() != 3 ){
		target = error( "if statement requires three arguments" );
		return;
	}

	Expr cond;
	args->head()->eval( cond, b->valueOps, rho, b );

	if( Scheme::isTrue(cond()) ){
		args->at(1)->eval( target, b->valueOps, rho, b );
	}else{
		args->at(2)->eval( target, b->valueOps, rho, b );
	}

	cond = 0;
}


};  //  namespace Kamin

