
#include "Kamin/IntegerBinaryFunction.h"
#include "Kamin/IntegerExpression.h"


namespace Kamin {


void IntegerBinaryFunction::applyWithArgs( Expr &target, ListNode *args, Environment *rho, Base *b ){
	Expression *left  = args->at(0);
	Expression *right = args->at(1);

	if( (! left ->isInteger()) ||
	    (! right->isInteger())    ){
		target = error("arithmetic function with nonint args");
		return;
	}
	
	target = new IntegerExpression(
		fun( left->isInteger()->val(), right->isInteger()->val() )
	);
}


};  //  namespace Kamin

