
/*!
	\file
	\class   IntegerBinaryFunction
	\ingroup g_kamin
	\brief   Integer Binary Functions
	\author  Samuel Kamin, Timothy Budd, Timo Suoranta
	\date    2000
*/


#ifndef TEDDY_KAMIN_INTEGER_BINARY_FUNCTION_H
#define TEDDY_KAMIN_INTEGER_BINARY_FUNCTION_H


#include "Kamin/BinaryFunction.h"


namespace Kamin {


class IntegerBinaryFunction : public BinaryFunction {
public:
	IntegerBinaryFunction(int (*thefun)(int, int)){
		fun = thefun;
	}

	virtual void applyWithArgs( Expr &target, ListNode *args, Environment *rho, Base *b );

private:
	int (*fun)(int, int);
};


};  //  namespace Kamin


#endif  //  TEDDY_KAMIN_INTEGER_BINARY_FUNCTION_H

