
#include "Kamin/LambdaFunction.h"
#include "Kamin/UserFunction.h"


namespace Kamin {


void LambdaFunction::apply( Expr &target, ListNode *args, Environment *rho, Base *b ){
	if( args->length() != 2 ){
		target = error("lambda requires two arguments");
		return;
	}

	ListNode *argNames = args->head()->isList();
	if( ! argNames ){
		target = error("lambda requires list of argument names");
		return;
	}

	target = new UserFunction( argNames, args->at(1), rho );
}


};  //  namespace Kamin

