
/*!
	\file
	\ingroup g_kamin
	\brief   Lisp functions
	\author  Samuel Kamin, Timothy Budd, Timo Suoranta
	\date    2000

	The core classes for the basic lisp functions
*/


#ifndef TEDDY_KAMIN_LISP_H
#define TEDDY_KAMIN_LISP_H


#include "Kamin/Expr.h"
#include "Kamin/Expression.h"


namespace Kamin {


//
//	The arithmetic functions
//
extern int  PlusFunction  ( int, int );
extern int  MinusFunction ( int, int );
extern int  TimesFunction ( int, int );
extern int  DivideFunction( int, int );
//
//	Relational functions
//
extern void EqualFunction      ( Expr &, Expression *, Expression * );
extern int  IntEqualFunction   ( int, int );
extern int  LessThanFunction   ( int, int );
extern int  GreaterThanFunction( int, int );
//
//	We can do Car and Cdr because they all evaluate their arguments
//	But we can't include cons because in chap5 is ceases to evaluate
//	its arguments
//
extern void CarFunction ( Expr &, Expression * );
extern void CdrFunction ( Expr &, Expression * );
extern void ConsFunction( Expr &, Expression *, Expression * );
//
//	predicates
//
extern int  NumberpFunction ( Expression * );
extern int  SymbolpFunction ( Expression * );
extern int  ListpFunction   ( Expression * );
extern int  NullpFunction   ( Expression * );
extern int  PrimoppFunction ( Expression * );
extern int  ClosurepFunction( Expression * );
extern void PrintFunction   ( Expr &, Expression * );


};  //  namespace Kamin


#endif  //  TEDDY_KAMIN_LISP_H

