
/*!
	\file
	\class   ListNode
	\ingroup g_kamin
	\brief   List define statement
	\author  Samuel Kamin, Timothy Budd, Timo Suoranta
	\date    2000
*/


#ifndef TEDDY_KAMIN_LIST_NODE_H
#define TEDDY_KAMIN_LIST_NODE_H


#include "Kamin/Expr.h"
#include "Kamin/Expression.h"


namespace Kamin {


class ListNode : public Expression {
public:
	ListNode( Expression *car, Expression *cdr );

	// overridden methods
	virtual void      free  ();
	virtual void      eval  ( Expr &target, Environment *valueops, Environment *rho, Base *b );
	virtual void      print ();
	virtual ListNode *isList();

	// list specific methods
	int         isNil ();
	int         length();
	Expression *at    ( int index );

	virtual Expression *head(){
		return h();
	}

	void                head( Expression *x ){
		h = x;
	}

	ListNode           *tail();

protected:
	Expr h;		// the head field
	Expr t;		// the tail field
};


};  //  namespace Kamin


#endif  //  EDDY_KAMIN_LIST_NODE_H

