
/*!
	\file
	\class   QuotedConst
	\ingroup g_kamin
	\brief   Lisp quoted constant atom
	\author  Samuel Kamin, Timothy Budd, Timo Suoranta
	\date    2000

	The Lisp reader adds quoted constants
*/


#ifndef TEDDY_KAMIN_QUOTED_CONST_H
#define TEDDY_KAMIN_QUOTED_CONST_H


#include "Kamin/Expr.h"
#include "Kamin/Expression.h"


namespace Kamin {


class QuotedConst : public Expression {

public:
	QuotedConst( Expression *val ){
		theValue = val;
	}

	virtual void free ();
	virtual void eval ( Expr &target, Environment *, Environment *, Base *b );
	virtual void print();

private:
	Expr theValue;
};


};  //  namespace Kamin


#endif  //  TEDDY_KAMIN_QUOTED_CONST_H

