
/*!
	\file
	\class   ReaderClass
	\ingroup g_kamin
	\author  Samuel Kamin, Timothy Budd, Timo Suoranta
	\date    2000
*/


#ifndef TEDDY_KAMIN_READER_H
#define TEDDY_KAMIN_READER_H


#include "Kamin/Expression.h"
#include "Kamin/IntegerExpression.h"
#include "Kamin/Symbol.h"
#include "Kamin/ListNode.h"
#include "Kamin/Base.h"


namespace Kamin {


class ReaderClass {
public:
	Expression *promptAndRead( Base *b, char *line=0 );

protected:
	char  buffer[1000];  //!<  The input buffer
	char *p;             //!<  Current location in buffer

	// general functions
	void printPrimaryPrompt  ();
	void printSecondaryPrompt();
	void fillInputBuffer     ();
	int  isSeparator         ( int c );
	void skipSpaces          ();
	void skipNewlines        ();

	// functions that can be overridden
	virtual Expression *readExpression( Base *b );

	// specific types of expressions
	int       readInteger();
	Symbol   *readSymbol ();
	ListNode *readList   ( Base *b );
};


};  //  namespace Kamin


#endif  //  TEDDY_KAMIN_READER_H

