
#include "Kamin/SetStatement.h"
#include "Kamin/Base.h"
#include "Kamin/Symbol.h"
#include <string.h>


namespace Kamin {


void SetStatement::apply( Expr &target, ListNode *args, Environment *rho, Base *b ){
	if( args->length() != 2 ){
		target = error("set statement requires two arguments");
		return;
	}

	// get the two parts
	Expression *my_expression = args->at(0);
	Symbol *my_sym = dynamic_cast<Symbol*>( my_expression );
	Symbol *sym    = NULL;
	if( my_sym!= NULL ){
		sym = args->at(0)->isSymbol();
		if( !sym ){
			target = error( "set commands require symbol for first arg" );
			return;
		}
	}else{
		target = error( "set commands require symbol for first arg" );
	}

	// set target to value of second argument
	args->at(1)->eval( target, b->valueOps, rho, b );

	// set it in the environment
	rho->set( sym, target() );
}


};  //  namespace Kamin

