
#include "Kamin/Symbol.h"
#include "Kamin/Environment.h"
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include "ui.h"  //  FIX


namespace Kamin {


Symbol::Symbol( char *t ){
	// make a new copy of text
	text = new char[strlen(t) + 1];
	if( !text ){
		error( " allocation failure for symbol ", t );
		exit( 1 );  //  FIX
	}
	strcpy( text, t );
}


void Symbol::free(){
	delete text;
}


void Symbol::eval( Expr &target, Environment *valueops, Environment *rho, Base *b ){
	Expression *result = rho->lookup( this );
	if( result ){
		result = result->touch();
	}else{
		result = error( "evaluation of unknown symbol: ", text );
	}
	target = result;
}


void Symbol::print(){
	*console << text;	
	printf( "%s", text );
}


Symbol *Symbol::isSymbol(){
	return this;
}


int Symbol::operator==( Expression *sym ){
	if( !sym ){
		return 0;
	}

	Symbol *s = sym->isSymbol();
	if( s ){
		return 0 == strcmp( text, s->text );
	}
	return 0;
}


int Symbol::operator==( char *t ){	
	return 0 == strcmp( text, t );
}


};  //  namespace Kamin

