
/*!
	\file
	\class   UnaryFunction
	\ingroup g_kamin
	\brief   Unary functions take only one argument
	\author  Samuel Kamin, Timothy Budd, Timo Suoranta
	\date    2000
*/


#ifndef TEDDY_KAMIN_UNARY_FUNCTION_H
#define TEDDY_KAMIN_UNARY_FUNCTION_H


#include "Kamin/Function.h"


namespace Kamin {


class UnaryFunction : public Function {
public:
	UnaryFunction(){
		fun = 0;
	}

	UnaryFunction( void (*afun)(Expr &, Expression *) ){
		fun = afun;
	}

	virtual void apply        ( Expr &target, ListNode *args, Environment *rho, Base *b );
	virtual void applyWithArgs( Expr &target, ListNode *args, Environment *rho, Base *b );

private:
	void (*fun)(Expr &, Expression *);
};


};  //  namespace Kamin


#endif  //  TEDDY_KAMIN_UNARY_FUNCTION_H

