
#include "Kamin/UserFunction.h"
#include "Kamin/Base.h"


namespace Kamin {


UserFunction::UserFunction( ListNode *anames, Expression *bod, Environment *ctx ){
	argNames = anames;
	body     = bod;
	context  = ctx;
}


void UserFunction::free(){
	argNames = 0;
	body     = 0;
	context  = 0;
}


int UserFunction::isClosure(){
	return 1;
}


void UserFunction::applyWithArgs( Expr &target, ListNode *args, Environment *rho, Base *b ){
	// number of args should match definition
	ListNode *an = argNames;
	if( an->length() != args->length() ){
		error( "argument length mismatch" );
		return;
	}

	// make new environment
	Env newrho; 
	newrho = new Environment( an, args, context );

	// evaluate body in new environment
	Expression *bod = body();
	if( bod ){
		bod->eval( target, b->valueOps, newrho, b );
	}else{
		target = 0;
	}

	newrho = 0;	 // force garbage collection
}


};  //  namespace Kamin

