
/*!
	\file
	\class   UserFunction
	\ingroup g_kamin
	\brief   User functions have argument names and body
	\author  Samuel Kamin, Timothy Budd, Timo Suoranta
	\date    2000
*/


#ifndef TEDDY_KAMIN_USER_FUNCTION_H
#define TEDDY_KAMIN_USER_FUNCTION_H


#include "Kamin/Function.h"


namespace Kamin {


class UserFunction : public Function {
public:
	UserFunction( ListNode *anames, Expression *bod, Environment *ctx );

	virtual void free         ();
	virtual void applyWithArgs( Expr &target, ListNode *args, Environment *rho, Base *b );
	virtual int  isClosure    ();

protected:
	List argNames;
	Expr body;
	Env  context;
};


};  //  namespace Kamin


#endif  //  TEDDY_KAMIN_USER_FUNCTION_H

