
#include "Kamin/WhileStatement.h"
#include "Kamin/Base.h"
#include "Kamin/Scheme.h"


namespace Kamin {


void WhileStatement::apply( Expr &target, ListNode *args, Environment *rho, Base *b ){
	Expr stmt;

	if( args->length() != 2 ){
		target = error( "while statement requires two arguments" );
		return;
	}

	//  Grab the two pieces of the statement
	Expression *condexp = args->at(0);
	Expression *stexp   = args->at(1);

	//  Then start the execution loop
	condexp->eval( target, b->valueOps, rho, b );
	while( Scheme::isTrue(target()) ){
		//  Evaluate body
		stexp->eval( stmt, b->valueOps, rho, b );
		//  But ignore it
		stmt = 0;
		//  Then reevaluate condition
		condexp->eval( target, b->valueOps, rho, b );
	}
}


};  //  namespace Kamin

