
/*
    TEDDY - General graphics application library
    Copyright (C) 1999, 2000  Timo Suoranta, Sean O' Neil

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    Timo Suoranta
    tksuoran@cc.helsinki.fi
*/


/*!
	\file
	\class   CTexture
	\ingroup g_materials
	\author  Sean O'Neil
	\date    2000
*/


#ifndef TEDDY_MATERIALS_C_TEXTURE_H
#define TEDDY_MATERIALS_C_TEXTURE_H


#include "DataStructures/CListNode.h"
#include "DataStructures/CLinkedList.h"
#include "Graphics/CColor.h"
#include "Graphics/OpenGL.h"
#include <string.h>
using namespace DataStructures;
using namespace Graphics;


namespace Materials {


#define CTextureList CLinkedList<CTexture>


class CTexture : public CListNode<CTexture> {
// Operations
public:
	CTexture(){
		memset( (char *)this, 0, sizeof(CTexture) );
	}
	~CTexture(){
		if( m_pTexture ){
			delete m_pTexture;
		}
	}
	void  SetType ( int n ){ m_nType = n; }
	int   GetType (){ return m_nType; }
	void  SetID   ( unsigned long n ){ m_dwID = n; }
	unsigned long GetID   (){ return m_dwID; }
	void  Enable  (){ glEnable(m_nType); glBindTexture(m_nType, m_dwID); }
	void  Disable (){ glDisable(m_nType); }
	void  BuildTexture( float fVariance );

// Attributes
protected:
	// Use glBindTexture(), like in glFlare demo
	int            m_nType;
	unsigned long  m_dwID;
	CFloatColor   *m_pTexture;
};


};  //  namespace Materials


#endif  //  TEDDY_MATERIALS_C_TEXTURE_H

