
/*
    TEDDY - General graphics application library
    Copyright (C) 1999, 2000  Timo Suoranta

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    Timo Suoranta
    tksuoran@cc.helsinki.fi
*/


#include "Materials/RawFileTexture.h"
#include "SysSupport/EndianIn.h"
using namespace SysSupport;


namespace Materials {


//!  Constructor-loader
RawFileTexture::RawFileTexture( const string &fname, const int width, const int height ):
Texture(name){
	EndianIn      *s      = NULL;
	unsigned char *filler = NULL;
	unsigned char *data   = NULL;
	int            len    = 256*256*3;

	try{
		s = new EndianIn( fname );
		s->set_bigendian();
		filler = data = new unsigned char[len];
		for( int i=0; i<len;i++){
			*filler++ = s->read_byte();
		}
		
	}catch( ... ){
	}
	s->close();

	glBindTexture  ( GL_TEXTURE_2D, gltid );
	glPixelStorei  ( GL_UNPACK_ALIGNMENT, 1 );
	glTexParameteri( GL_TEXTURE_2D, GL_TEXTURE_WRAP_S,     GL_CLAMP );
	glTexParameteri( GL_TEXTURE_2D, GL_TEXTURE_WRAP_T,     GL_CLAMP );
	glTexParameteri( GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR );
	glTexParameteri( GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR );
	glTexEnvi      ( GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE );
	glTexImage2D   ( GL_TEXTURE_2D, 0, GL_RGB, 256, 256, 0, GL_RGB, GL_UNSIGNED_BYTE, data );
	delete[] data;
}


};  //  namespace Materials

