
/*
    TEDDY - General graphics application library
    Copyright (C) 1999, 2000  Timo Suoranta

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    Timo Suoranta
    tksuoran@cc.helsinki.fi
*/


/*!
	\class   Texture
	\ingroup g_materials
	\author  Timo Suoranta
	\brief   Component texture
	\warning Very incomplete
	\bug     Destructors missing?
	\date    1999, 2000
*/


#ifndef TEDDY_MATERIALS_TEXTURE_H
#define TEDDY_MATERIALS_TEXTURE_H


#include "Graphics/OpenGL.h"
#include <string>
using namespace std;
//using namespace Graphics;


namespace Materials {


class Texture {
public:
	Texture( const string &name );
	virtual ~Texture();

	void glApply();
	void loadPIX( char *fname );

protected:
	string name;
	GLuint gltid;
};


};  //  namespace Materials


#endif  //  TEDDY_MATERIALS_TEXTURE_H

