
/*
    TEDDY - General graphics application library
    Copyright (C) 1999, 2000  Timo Suoranta

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    Timo Suoranta
    tksuoran@cc.helsinki.fi
*/


/*!
	\class   ColumnToVector4
	\ingroup g_maths
	\author  Timo Suoranta
	\brief   Four-vector extracted from matrix column
	\date    1999
*/


#ifndef TEDDY_MATHS_COLUMN_TO_VECTOR4
#define TEDDY_MATHS_COLUMN_TO_VECTOR4


#include "Maths/Vector4.h"
#include "Maths/Matrix.h"


namespace Maths {


class ColumnToVector4 : public Vector4 {	
public:
	ColumnToVector4( const Matrix &m, const int col );
};


};  //  namespace Maths


#endif  //  TEDDY_MATHS_COLUMN_TO_VECTOR4

