
/*
    TEDDY - General graphics application library
    Copyright (C) 1999, 2000  Timo Suoranta

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    Timo Suoranta
    tksuoran@cc.helsinki.fi
*/


#include "Maths/CrossVector4.h"


namespace Maths {


CrossVector4::CrossVector4( const Vector4 &r, const Vector4 &s, const Vector4 &t ){
	x = r.y*s.z*t.w + r.z*s.w*t.y + r.w*s.y*t.z -
	    r.y*s.w*t.z - r.z*s.y*t.w - r.w*s.z*t.y;

	y = r.x*s.w*t.z + r.z*s.x*t.w + r.w*s.z*t.x -
	    r.x*s.z*t.w - r.z*s.w*t.x - r.w*s.x*t.z; 
      
	z = r.x*s.y*t.w + r.y*s.w*t.x + r.w*s.x*t.y -
	    r.x*s.w*t.y - r.y*s.x*t.w - r.w*s.y*t.x;
      
	w = r.x*s.z*t.y + r.y*s.x*t.z + r.z*s.y*t.x - 
	    r.x*s.y*t.z - r.y*s.z*t.x - r.z*s.x*t.y;

}


};  //  namespace Maths

