
/*
    TEDDY - General graphics application library
    Copyright (C) 1999, 2000  Timo Suoranta

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    Timo Suoranta
    tksuoran@cc.helsinki.fi
*/


#include "Maths/OrtUnitVector.h"


namespace Maths {


//!  Constructor
OrtUnitVector::OrtUnitVector( const Vector &v, const Vector &to ){
	double a;
    a = v.r*to.r + v.s*to.s + v.t*to.t;

	r = v.r - a*to.r;
    s = v.s - a*to.s;
	t = v.t - a*to.t;
};


};  //  namespace Maths


