
/*
    TEDDY - General graphics application library
    Copyright (C) 1999, 2000  Timo Suoranta

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    Timo Suoranta
    tksuoran@cc.helsinki.fi
*/


/*!
	\class   OrtUnitVector
	\ingroup g_maths
	\author  Timo Suoranta
	\brief   Vector which is unit length and orthogonal to given two vectors
	\date    1999
*/


#ifndef TEDDY_MATHS_ORT_UNIT_VECTOR_H
#define TEDDY_MATHS_ORT_UNIT_VECTOR_H


#include "Maths/Vector.h"
#include <math.h>
#include <float.h>


namespace Maths {


class OrtUnitVector : public Vector {
public:
	OrtUnitVector( const Vector &v, const Vector &to );
};


};  //  namespace Maths



#endif  //  TEDDY_MATHS_ORT_UNIT_VECTOR_H

