
/*
    TEDDY - General graphics application library
    Copyright (C) 1999, 2000  Timo Suoranta

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    Timo Suoranta
    tksuoran@cc.helsinki.fi
*/


/*!
	\class   Plane
	\ingroup g_maths
	\author  Timo Suoranta
	\brief   Plane equation
	\date    1999, 2000
*/


#ifndef TEDDY_MATHS_PLANE_H
#define TEDDY_MATHS_PLANE_H


#include "Maths/Vector.h"


namespace Maths {


class Plane : public Vector {
public:
	double d;

	Plane( const double A, const double B, const double C, const double D );
	Plane( const Vector &p1, const Vector &p2, const Vector &p3 );

	void    Neg      ();
	bool    aEq      ( const Plane &p, double dir_t, double dist_t ) const;
	double  distance ( const Vector &p ) const;
	Plane  &operator=( const Vector &v );

	virtual void debug() const;
};


};  //  namespace Maths


#endif  //  TEDDY_MATHS_PLANE_H


