
/*
    TEDDY - General graphics application library
    Copyright (C) 1999, 2000  Timo Suoranta

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    Timo Suoranta
    tksuoran@cc.helsinki.fi
*/


#include "Maths/RotationMatrix.h"
#include "Maths/SpaceWarpMatrix.h"
#include "Maths/Vector.h"


namespace Maths {


RotationMatrix::RotationMatrix( const double r, const Vector &orig, const Vector &axis ){
    Vector x, y, z, nx, ny, t;
	double cosr, sinr;

    cosr = cos( r );
	sinr = sin( r );

    axis.GetPerpVect( x, y );
	z = (y * x); z.Norm();
    y = (z * x); y.Norm();

	nx = x * cosr;
    t  = y * sinr;
	nx += t;

    ny = x * -sinr;
	t  = y *  cosr;
    ny += t;

	Matrix m = SpaceWarpMatrix( orig, x, y, z, orig, nx, ny, z );
	(*this).Copy( m );
/*	(*this).operator=( m );
	*this = m;*/
}


};  //  namespace Maths

