
/*
    TEDDY - General graphics application library
    Copyright (C) 1999, 2000  Timo Suoranta

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    Timo Suoranta
    tksuoran@cc.helsinki.fi
*/


#include "Maths/SpaceMatrix.h"
#include "Maths/Vector.h"


namespace Maths {


SpaceMatrix::SpaceMatrix( const Vector &o, const Vector &x, const Vector &y, const Vector &z ){
	A[0][0] = x.r;
	A[1][0] = x.s;
	A[2][0] = x.t;
	A[3][0] = 0.0;

	A[0][1] = y.r;
	A[1][1] = y.s;
	A[2][1] = y.t;
	A[3][1] = 0.0;

	A[0][2] = z.r;
    A[1][2] = z.s;
    A[2][2] = z.t;
	A[3][2] = 0.0;

	A[0][3] = o.r;    
	A[1][3] = o.s;
	A[2][3] = o.t;
	A[3][3] = 1.0;
}


};  //  namespace Maths

