
/*
    TEDDY - General graphics application library
    Copyright (C) 1999, 2000  Timo Suoranta

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    Timo Suoranta
    tksuoran@cc.helsinki.fi
*/


/*!
	\class   SpaceWarpMatrix
	\ingroup g_maths
	\author  Timo Suoranta
	\brief   4x4 matrix to help transform from one space to another
	\date    1999
*/


#ifndef TEDDY_MATHS_SPACE_WARP_MATRIX_H
#define TEDDY_MATHS_SPACE_WARP_MATRIX_H


#include "Maths/Matrix.h"


namespace Maths {


class Vector;


class SpaceWarpMatrix : public Matrix {
public:
	SpaceWarpMatrix( const Vector &fo, const Vector &fx, const Vector &fy, const Vector &fz,
	                 const Vector &to, const Vector &tx, const Vector &ty, const Vector &tz  );		            
};


};  //  namespace Maths


#endif  //  TEDDY_MATHS_SPACE_WARP_MATRIX_H

