
/*
    TEDDY - General graphics application library
    Copyright (C) 1999, 2000  Timo Suoranta

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    Timo Suoranta
    tksuoran@cc.helsinki.fi
*/


/*!
	\class   TransposeMatrix
	\ingroup g_maths
	\author	 Timo Suoranta
	\brief   4x4 matrix transpose operation, also used to load matrix to OpenGL format
	\date    1999
*/


#ifndef TEDDY_MATHS_TRANSPOSE_MATRIX_H
#define TEDDY_MATHS_TRANSPOSE_MATRIX_H


#include "Maths/Matrix.h"


namespace Maths {


class TransposeMatrix : public Matrix {
public:
	TransposeMatrix( const Matrix &m );

	void glLoad();
	void glMult();
};


};  //  namespace Maths


#endif  //  TEDDY_MATHS_TRANSPOSE_MATRIX_H

