
/*
    TEDDY - General graphics application library
    Copyright (C) 1999, 2000  Timo Suoranta

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    Timo Suoranta
    tksuoran@cc.helsinki.fi
*/


/*
	\file    trigmath.h
	\ingroup g_maths
	\author  Timo Suoranta
	\brief   Math routine defines
	\date    2000
*/


#ifndef TEDDY_MATHS_TRIGMATH_H
#define TEDDY_MATHS_TRIGMATH_H


#include <math.h>
#include <float.h>
#include <limits.h>


#undef M_PI
#define M_PI (3.14159265358979323846264338327950288419716939937510)
#undef M_2_PI
#define M_2_PI (2*M_PI)
#define DEGS_PER_RAD (57.29577951308232286465)
#define RADS_PER_DEG ( 0.01745329251994329547)
#define degs(x) (x*DEGS_PER_RAD)
#define rads(x) (x*RADS_PER_DEG)


#endif  //  TEDDY_MATHS_TRIGMATH_H


