
/*
    TEDDY - General graphics application library
    Copyright (C) 1999, 2000  Timo Suoranta

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    Timo Suoranta
    tksuoran@cc.helsinki.fi
*/


/*!
	\class   Element
	\ingroup g_models
	\author  Timo Suoranta
	\brief   Abstract piece of Mesh
	\bug     Destructors missing?
	\date    1999, 2000

	Element is simple renderable part of mesh.

	Although Element has method draw, it is draw() const, and
	Element is NOT renderable.
*/


#ifndef TEDDY_MODELS_ELEMENT_H
#define TEDDY_MODELS_ELEMENT_H


#include "Graphics/RenderContext.h"


namespace Models {


class Element {
public:
	//int state;
	virtual void draw () const = 0;
	virtual void debug();
};


};  //  namespace Models


#endif  //  TEDDY_MODELS_ELEMENT_H

