
/*
    TEDDY - General graphics application library
    Copyright (C) 1999, 2000  Timo Suoranta

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    Timo Suoranta
    tksuoran@cc.helsinki.fi
*/


/*!
	\class   Grid
	\ingroup g_models
	\author  Timo Suoranta
	\brief   (xz) plane grid LineMesh
	\bug     This class or some baseclass is broken (gl error when lighting enabled)
	\date    1999, 2000

	Class for very simple grid Mesh
*/


#ifndef TEDDY_MODELS_GRID_H
#define TEDDY_MODELS_GRID_H


#include "Models/LineMesh.h"


namespace Models {


class Grid : public LineMesh {
public:					  
	Grid( const int xCount, const int zCount, const double xSize, const double zSize );

protected:
	int      xCount;
	int      zCount;
	GLfloat  xSize;
	GLfloat  zSize;
	GLfloat  left;
	GLfloat  right;
	GLfloat  fore;
	GLfloat  back;
};


};  //  namespace Models


#endif  //  TEDDY_MODELS_GRID_H

