
/*
    TEDDY - General graphics application library
    Copyright (C) 1999, 2000  Timo Suoranta

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    Timo Suoranta
    tksuoran@cc.helsinki.fi
*/


/*!
	\class   LineMesh
	\ingroup g_models
	\author  Timo Suoranta
	\brief   LineMesh is a set of lines, suitabale for grid for example
	\bug     Destructors missing?
	\bug     There is something wrong in LineMesh, since having grid in scenes disables roam
	         in test scene - FIX
	\date    1999, 2000
*/


#ifndef TEDDY_MODELS_LINE_MESH_H
#define TEDDY_MODELS_LINE_MESH_H


#include "Materials/Material.h"
#include "Models/Mesh.h"
#include <string>
using namespace Materials;
using namespace std;


namespace Models {


class LineMesh : public Mesh {
public:
	LineMesh();
	LineMesh( const string &name, Material *mat );
	virtual ~LineMesh();

	//  Mesh Interface
	virtual void beginElements( RenderContext *rc );
	virtual void endElements  ( RenderContext *rc );
};


};  //  namespace Models


#endif  //  TEDDY_MODELS_LINE_MESH_H

