
/*
    TEDDY - General graphics application library
    Copyright (C) 1999, 2000  Timo Suoranta

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    Timo Suoranta
    tksuoran@cc.helsinki.fi
*/


#include "Models/PointMesh.h"
#include "Graphics/OpenGL.h"


namespace Models {


PointMesh::PointMesh( const string &name, Material *mat ):Mesh(name,mat){
}


//!  Mesh Interface - Pre drawing code for PointMesh
/*virtual*/ void PointMesh::beginElements( RenderContext *rc ){
	glBegin( GL_POINTS );
}


//!  Mesh Interface - Post drawing code for PointMesh
/*virtual*/ void PointMesh::endElements( RenderContext *rc ){
	glEnd();
}


};  //  namespace Models

