
/*
    TEDDY - General graphics application library
    Copyright (C) 1999, 2000  Timo Suoranta

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    Timo Suoranta
    tksuoran@cc.helsinki.fi
*/


#include "Models/QuadStrip.h"
#include "Models/Vertex.h"
#include "Graphics/OpenGL.h"


namespace Models {


//!  Default constructor
QuadStrip::QuadStrip(){
}


//!  Destructor
QuadStrip::~QuadStrip(){
	//  FIX
}


//!  Insert vertex to QuadStrip
void QuadStrip::insert( Vertex *v ){
	vertices.push_back( v );
}


//!  Draw QuadStrip
void QuadStrip::draw() const {
	glBegin( GL_QUAD_STRIP );
	list<Vertex*>::const_iterator v_it = vertices.begin();
	while( v_it != vertices.end() ){
		(*v_it)->draw();
		v_it++;
	}
	glEnd();
}


};  //  namespace Models

