
/*
    TEDDY - General graphics application library
    Copyright (C) 1999, 2000  Timo Suoranta

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    Timo Suoranta
    tksuoran@cc.helsinki.fi
*/


/*!
	\class   SmoothVertex
	\ingroup g_models
	\author  Timo Suoranta
	\brief   Vertex which also has normal Vector
	\bug     Destructors missing?
	\date    1999, 2000
*/


#ifndef TEDDY_MODELS_SMOOTH_VERTEX_H
#define TEDDY_MODELS_SMOOTH_VERTEX_H


#include "Models/Vertex.h"


namespace Models {


class SmoothVertex : public Vertex {
public:
	SmoothVertex();
	SmoothVertex( const double r, const double s, const double t );
	SmoothVertex( const Vector &v );

	void setNormal( const Vector &normal );
	void addNormal( const Vector &add );
	void normNormal();

	virtual void draw() const;

protected:
	Vector normal;
};


};  //  namespace Models


#endif  //  TEDDY_MODELS_SMOOTH_VERTEX_H

