
/*
    TEDDY - General graphics application library
    Copyright (C) 1999, 2000  Timo Suoranta

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    Timo Suoranta
    tksuoran@cc.helsinki.fi
*/


/*!
	\class   Sphere
	\ingroup g_models
	\author	 Timo Suoranta
	\brief   Sphere Mesh
	\date    2000

	Sphere mesh done with stacks and slices -method
	(like glut). Sphere currently only uses QuadStrip
	elemets, the two TriangleFan elements will be added 
	later.
*/


#ifndef TEDDY_MODELS_SPHERE_H
#define TEDDY_MODELS_SPHERE_H


#include "Models/Mesh.h"


namespace Models {


class Sphere : public Mesh {
public:
	Sphere( const string &name, const double radius, const int stacks, const int slices );

protected:
	double radius;
	int    stacks;
	int    slices;
};


};  //  namespace Models


#endif  //  TEDDY_MODELS_SPHERE_H

