
/*
    TEDDY - General graphics application library
    Copyright (C) 1999, 2000  Timo Suoranta

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    Timo Suoranta
    tksuoran@cc.helsinki.fi
*/


#include "Models/Vertex.h"
#include "Graphics/OpenGL.h"


namespace Models {


//!  Debugging information
void Vertex::debug(){
	Vector::debug();
}


//!  Default constructor
Vertex::Vertex():Vector(){
}


//!  Vertex - Vector Copy-constructor
Vertex::Vertex( const Vector &v ):Vector(v){
}


//!  Vertex Component constructor
Vertex::Vertex( const double r, const double s, const double t):Vector(r,s,t){
}


/*!
	Draw. Does NOT include glBegin(), so
	can be used with any OpenGL primitives, but
	needs glBegin() outside
*/
void Vertex::draw() const {
	glVertex3f( r, s, t );
}


};  //  namespace Models

