
/*
    TEDDY - General graphics application library
    Copyright (C) 1999, 2000  Timo Suoranta

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    Timo Suoranta
    tksuoran@cc.helsinki.fi
*/


/*!
	\defgroup g_models Models
*/

/*!

\page p_models Models

This documentation is slightly out of date. Models are
still work-in-progress, so prepare for changes. Especially
note that currently there is no support for vertex arrays.

Models module contains classes to maintain model
modeling and rendering data. Mesh is baseclass
for all modeling and rendering.

Important method of Mesh is drawElements().

Mesh holds a collection of Elements, and in case of sphere
for example, those Elements are Triangles. Triangle is defined
by its corner vertices. Triangles has ability to be subdivided.
By default each Triangle is subdived twice at the moment (hardcoded,
will have to change). Triangles also only work with spherical
surfaces at the moment.

A simpler method to model Icosahedron was used earlier, which
used Faces. Face is a set of vertices like triangle, but it is
not limited to three vertices, and can not be subdivided (at the
moment, could be added later). Face baseclass does not contain
normal vector information, so it should be used for models without
lighting only. Meshes that use lighting should use FlatFace or
SmoothFace. FlatFace contains single normal vector which is set
for all vertices. SmoothFace vertices are specific SmoothVertices,
which contain normal vector in addion to the vector itself; thus
all vertices of SmoothFace contain normal vector as well.

There can be several \link ModelInstance ModelInstances\endlink 
of Mesh, each having some extra properties
(like Material) for the Mesh.

*/
