
/*
    TEDDY - General graphics application library
    Copyright (C) 1999, 2000  Timo Suoranta

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    Timo Suoranta
    tksuoran@cc.helsinki.fi
*/


#include "PhysicalComponents/GradientFill.h"


namespace PhysicalComponents {


//!  Default constructor
GradientFill::GradientFill( const Color &left_top, const Color &right_top, const Color &right_bottom, const Color &left_bottom ):Fill(){
	//  Assign colors
	this->left_top     = left_top;
	this->right_top    = right_top;
	this->right_bottom = right_bottom;
	this->left_bottom  = left_bottom;
}


//!  Rendering overlay window
void GradientFill::drawSelf(){	
	int width;
	int height;

	getSize( &width, &height );
	glPushAttrib( GL_ALL_ATTRIB_BITS );

	glEnable( GL_BLEND );
	//  FIX add glPolygonMode();
	glBlendFunc( GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA );
	glDisable( GL_CULL_FACE );
	glShadeModel( GL_SMOOTH );
	glBegin( GL_QUADS );
	glColor4fv( left_top.rgba );
	vertex2i( 0, 0 );
	glColor4fv( right_top.rgba );
	vertex2i( width, 0 );
	glColor4fv( right_bottom.rgba );
	vertex2i( width, height );
	glColor4fv( left_bottom.rgba );
	vertex2i( 0, height );
	glEnd();

	glPopAttrib();

}


};  //  namespace PhysicalComponents

