
/*
    TEDDY - General graphics application library
    Copyright (C) 1999, 2000  Timo Suoranta

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    Timo Suoranta
    tksuoran@cc.helsinki.fi
*/


/*!
	\class   HDock
	\ingroup g_physical_components
	\author  Timo Suoranta
	\brief   Horizontal docking components
	\date    2000

*/


#ifndef TEDDY_PHYSICAL_COMPONENTS_H_DOCK_H
#define TEDDY_PHYSICAL_COMPONENTS_H_DOCK_H


#include "PhysicalComponents/Dock.h"
#include <list>
using namespace std;


namespace PhysicalComponents {


class HDock : public Dock {
public:
	HDock();
	virtual ~HDock();

	//  Area Layout Interface
	virtual void place     ( int offset_x = 0, int offset_y = 0 );
	virtual void getMinSize( int *min_width, int *min_height ) const;  //!<  Query minimal accepted size for Area

protected:
	virtual void placeOne  ( Area *area );
};


};  //  namespace PhysicalComponents


#endif  //  TEDDY_PHYSICAL_COMPONENTS_H_DOCK_H

