
/*
    TEDDY - General graphics application library
    Copyright (C) 1999, 2000  Timo Suoranta

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    Timo Suoranta
    tksuoran@cc.helsinki.fi
*/


#include "PhysicalComponents/Layer.h"
#include "PhysicalComponents/LayoutConstraint.h"
#include "Graphics/OpenGL.h"


namespace PhysicalComponents {


//!  Constructor
Layer::Layer( const string &name, View *view ):Area(){
	GLint *viewp = view->getViewport();
	this->parent = NULL;
	this->name   = name;
	this->view   = view;
	constraint = new LayoutConstraint();  //  FIX
	constraint->local_x_fill_pixels = viewp[2] - viewp[0];
	constraint->local_y_fill_pixels = viewp[3] - viewp[1];
	place();
}


//!  Set View
void Layer::update( View *view ){ // refresh/update, on resize for example
	GLint *viewp = view->getViewport();
	constraint->local_x_fill_pixels = viewp[2] - viewp[0];
	constraint->local_y_fill_pixels = viewp[3] - viewp[1];
/*	viewport[0] = viewp[0];
	viewport[1] = viewp[1];
	viewport[2] = viewp[2];
	viewport[3] = viewp[3];*/
	place();
}


};  //  namespace PhysicalComponents

