
/*
    TEDDY - General graphics application library
    Copyright (C) 1999, 2000  Timo Suoranta

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    Timo Suoranta
    tksuoran@cc.helsinki.fi
*/


/*!
	\class   Moving
	\ingroup g_physical_components
	\author  Timo Suoranta
	\brief   Moving gadget
	\date    2000
*/


#ifndef TEDDY_PHYSICAL_COMPONENTS_MOVING_H
#define TEDDY_PHYSICAL_COMPONENTS_MOVING_H


#include "PhysicalComponents/Area.h"
#include "Inputs/MouseListener.h"
using namespace Inputs;


namespace PhysicalComponents {


class Moving : public Area, public MouseListener {
public:
	Moving();
	virtual ~Moving();

	//  Area interface
	virtual void drawSelf();

	//  MouseListener interface
	virtual void mouseKey   ( int button, int state, int x, int y );
	virtual void mouseMotion( int x, int y );

protected:
	//  Fix later
	int mouse_x[3];
	int mouse_y[3];
	int mouse_b[3];
};


};  //  namespace PhysicalComponents


#endif  //  TEDDY_PHYSICAL_COMPONENTS_MOVING_H

