
/*
    TEDDY - General graphics application library
    Copyright (C) 1999, 2000  Timo Suoranta

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    Timo Suoranta
    tksuoran@cc.helsinki.fi
*/


#include "PhysicalComponents/Projection.h"
#include "PhysicalComponents/WindowFrame.h"


namespace PhysicalComponents {


//! Constructor
Projection::Projection( Camera *camera ){
	ordering = post_self;
	this->camera = camera;

/*	this->insert(
		new WindowFrame( "Camera View" )
	);*/

//	camera->connect( this );

}


//!  Destructor
/*virtual*/ Projection::~Projection(){
	//  FIX
}


//!  Drawing code
/*virtual*/ void Projection::drawSelf(){
	GLint *viewp;

	//  Reversing y coordinates because of OpenGL has mixed up and down..
#ifdef USE_WINDOW_SYSTEM
	viewp = view->getViewport();
	glViewport( viewport[0], viewp[3]-viewport[3], viewport[2]-viewport[0], viewport[3]-viewport[1] );
	glScissor ( viewport[0], viewp[3]-viewport[3], viewport[2]-viewport[0], viewport[3]-viewport[1] );
	glEnable( GL_SCISSOR_TEST );
	glClearDepth( 1.0 );
	glClearColor( 0.0f, 0.0f, 0.0f, 1.0f );
	glDepthRange( 0.0, 1.0 );
	glClear( GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT );
	camera->projectScene( this );
	glDisable( GL_SCISSOR_TEST );
	glScissor( viewp[0], viewp[1], viewp[2], viewp[3] );
#else
	camera->projectScene( this );
#endif
}


};  //  namespace PhysicalComponents

