
/*
    TEDDY - General graphics application library
    Copyright (C) 1999, 2000  Timo Suoranta

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    Timo Suoranta
    tksuoran@cc.helsinki.fi
*/


/*!
	\class   Projection
	\ingroup g_physical_components
	\author  Timo Suoranta
	\brief   Areas that set custom projection matrix
	\date    2000
*/


#ifndef TEDDY_PHYSICAL_COMPONENTS_PROJECTION_H
#define TEDDY_PHYSICAL_COMPONENTS_PROJECTION_H


#include "PhysicalComponents/Area.h"
#include "Scenes/Camera.h"
using namespace Scenes;


#if defined( WIN32 )
#pragma warning(disable:4786)
#endif



namespace PhysicalComponents {


class Projection : public Area {
public:
	Projection( Camera *camera );
	virtual ~Projection();
	
	virtual void drawSelf();

protected:
	Camera *camera;
};


};  //  namespace PhysicalComponents


#endif  //  TEDDY_PHYSICAL_COMPONENTS_PROJECTION_H

