
/*
    TEDDY - General graphics application library
    Copyright (C) 1999, 2000  Timo Suoranta

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    Timo Suoranta
    tksuoran@cc.helsinki.fi
*/


/*!
	\class   WindowFrame
	\ingroup g_physical_components
	\author  Timo Suoranta
	\brief   Frame decoration area for Windows with title bar
	\warning Very incomplete
	\bug     Destructors missing
	\date    2000

	Currently testing HDock

	'Move Window' behaviour hacked in
	
*/


#ifndef TEDDY_PHYSICAL_COMPONENTS_WINDOW_FRAME_H
#define TEDDY_PHYSICAL_COMPONENTS_WINDOW_FRAME_H


#include "PhysicalComponents/HDock.h"
#include <string>
using namespace std;


namespace PhysicalComponents {


class WindowFrame : public HDock/*, public MouseListener*/ {
public:
	WindowFrame( string name );
    virtual ~WindowFrame();

	//  Area interface
	virtual void drawSelf();

	//  Area Layout Interface
	virtual void moveDelta    ( const int x_delta, const int y_delta );   //!<  Move Area
	virtual void sizeDelta    ( const int x_delta, const int y_delta );   //!<  Resize Area

	//  MouseListener interface
/*	virtual void mouseKey   ( int button, int state, int x, int y );
	virtual void mouseMotion( int x, int y );*/
};


};  //  namespace PhysicalComponents


#endif  //  TEDDY_PHYSICAL_COMPONENTS_WINDOW_FRAME_H

