
/*
    TEDDY - General graphics application library
    Copyright (C) 1999, 2000  Timo Suoranta

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    Timo Suoranta
    tksuoran@cc.helsinki.fi
*/


/*!
	\class   RigidBody
	\ingroup g_physics
	\author  Timo Suoranta
	\brief   Simple animation system
	\date    2000
*/


#ifndef TEDDY_PHYSICS_RIGID_BODY_H
#define TEDDY_PHYSICS_RIGID_BODY_H


#include "Models/ModelInstance.h"
#include "Maths/Matrix.h"
#include "Maths/Vector.h"
using namespace Models;


namespace Physics {


class RigidBody {
public:
	Vector tick_translation;
	Vector tick_translation_delta;  //!<  acceleration
	Vector tick_rotation;
	Vector tick_rotation_delta;     //!<  angular acceleration

	RigidBody( ModelInstance *mi=NULL );
	virtual ~RigidBody();

	void           setInstance( ModelInstance *instance );
	ModelInstance *getInstance();
	virtual void   tick       ();

protected:
	ModelInstance *instance;
};


};  //  namespace Physics


#endif  //  TEDDY_PHYSICS_RIGID_BODY_H

