
/*
    TEDDY - General graphics application library
    Copyright (C) 1999, 2000  Timo Suoranta

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    Timo Suoranta
    tksuoran@cc.helsinki.fi
*/


/*!
	\class   System
	\ingroup g_physics
	\author  Timo Suoranta
	\brief   Simple animation system
	\date    2000
*/


#ifndef TEDDY_PHYSICS_SYSTEM_H
#define TEDDY_PHYSICS_SYSTEM_H


#include "Physics/RigidBody.h"
#include <list>
using namespace std;


#define SIMULATION_INTERVAL_MS 10


namespace Physics {


class System {
public:
	System();
	virtual ~System();

	void             addRigidBody  ( RigidBody *rb );
	float            getTime       ();
	list<RigidBody*> getRigidBodies();
	void             update        ();

protected:
	list<RigidBody*> rigid_bodies;
	float            sys_time;
};


};  //  namespace Physics


#endif  //  TEDDY_PHYSICS_SYSTEM_H

