
/*
    TEDDY - General graphics application library
    Copyright (C) 1999, 2000  Timo Suoranta

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    Timo Suoranta
    tksuoran@cc.helsinki.fi
*/


/*!
	\class   Timer
	\ingroup g_syssupport
	\author  Timo Suoranta
	\brief   Timer
	\todo    Rewrite using SDL
	\date    2000
*/


#ifndef TEDDY_SYS_SUPPORT_TIMER_H
#define TEDDY_SYS_SUPPORT_TIMER_H


// win32 implementation
#if defined(WIN32)


class Timer {
public:
	Timer();

	void  Update();
	float Passed();
};


// FIXME: add a check for POSIX systems...
#elif 1


#include <sys/time.h>


class Timer
{
public:
	inline void  Update();
	inline float Passed();

private:
	timeval last;
};


inline void Timer::Update(){
#if 0
	gettimeofday( &last, NULL );
#endif
}


inline float Timer::Passed(){
#if 0
	timeval now, diff;
	gettimeofday( &now, NULL );
	//timersub( &now, &last, &diff );
	double result = diff.tv_sec+((double)diff.tv_usec/1000000.0);
	return result;
#else
	return 0.1;
#endif
}


#else

#error "Target has no implementation for Timer class"


#endif //  WIN32


#endif  //  TEDDY_SYS_SUPPORT_TIMER_H


