
/*
    TEDDY - General graphics application library
    Copyright (C) 1999, 2000  Timo Suoranta

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    Timo Suoranta
    tksuoran@cc.helsinki.fi
*/


#include "TestLayer.h"
#include "Inputs/FocusManager.h"
#include "PhysicalComponents/Button.h"
#include "ui.h"
using namespace Inputs;


//!  Constructor
TestLayer::TestLayer( UI *ui, View *view ):Layer("Display",view){
	this->ui         = ui;
	//this->input_task = input_task;
	//this->insert( new Button( "Quit" ) );
	FocusManager::registerArea( this );
}


//!  KeyListener interface implementation
/*virtual*/ void TestLayer::keyDown( SDL_keysym key ){
	switch( key.sym ){
	case 'h': ui->displayHelp();          break;
	case 'e': ui->displayExtensions();    break;
	case 'a': ui->instanceFace();         break;
	case 'n': ui->polygonModeLine();      break;
	case 'm': ui->polygonModeFill();      break;
	case 'v': ui->cullFaceDisable();      break;
	case 'b': ui->cullFaceEnable();       break;
	case 'f': ui->depthTestDisable();     break;
	case 'g': ui->depthTestEnable();      break;
	case 'k': ui->lightingOff();          break;
	case 'l': ui->lightingOn();           break;
	case 'i': ui->fovNormal();            break;
	case 'o': ui->fovWide();              break;
	case 'r': ui->antialiseOff();         break;
	case 't': ui->antialiseOn();          break;
	case '3': ui->chooseMouseMode();      break;
	case '4': ui->instanceCycle();        break;
	case 'q': ui->quit();                 break;
	default: break;
	}
	//input_task->keyDown( key );
};


/*virtual*/ void TestLayer::keyUp( SDL_keysym key ){
	//input_task->keyUp( key );
};


//!  MouseListener interface
/*virtual*/ void TestLayer::mouseKey( int button, int state, int x, int y ){
/*	int old_state = button_state;

	int new_up   =  state & ~button_state;
	int new_down = ~state &  button_state;

	SDL_BUTTON(SDL_BUTTON_LEFT)
	SDL_BUTTON(SDL_BUTTON_MIDDLE)
	SDL_BUTTON(SDL_BUTTON_RIGHT)
*/

	if( state==SDL_PRESSED ){
		mouse_x[button] = x;
		mouse_y[button] = y;
	}else{
		if( button==SDL_BUTTON_LEFT && state==SDL_RELEASED && x==mouse_x[button] && y==mouse_y[button] ){
			ui->selectInstance( x, y );
		}
	}
	mouse_b[button] = state;
}


/*virtual*/ void TestLayer::mouseMotion( int x, int y ){
	for( int b=1; b<4; b++ ){
		if( mouse_b[b]==SDL_PRESSED ){
			int x_delta = mouse_x[b] - x;
			int y_delta = mouse_y[b] - y;
			mouse_x[b] = x;
			mouse_y[b] = y;
			ui->mouseMotion( b, x_delta, y_delta );
		}
	}
}

