
/*
    TEDDY - General graphics application library
    Copyright (C) 1999, 2000  Timo Suoranta

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    Timo Suoranta
    tksuoran@cc.helsinki.fi
*/


/*!
	\class   TestLayer
	\ingroup g_testing_environment
	\author  Timo Suoranta
	\brief   Test env display layer that also acts as test focus manager
	\date    2000
*/


#ifndef TEDDY_TEST_TEST_LAYER_H
#define TEDDY_TEST_TEST_LAYER_H


class UI;
#include "PhysicalComponents/Layer.h"
#include "Inputs/FocusManager.h"
using namespace PhysicalComponents;
using namespace Inputs;


class TestLayer : public Layer, public KeyListener, public MouseListener {
public:
	TestLayer( UI *ui, View *view );
	
	//  KeyListener interface
	virtual void keyDown( SDL_keysym key );
	virtual void keyUp  ( SDL_keysym key );

	//  MouseListener interface
	virtual void mouseKey   ( int button, int state, int x, int y );
	virtual void mouseMotion( int x, int y );
	
protected:
	UI        *ui;
	int        mouse_x[4];
	int        mouse_y[4];
	int        mouse_b[4];
};


#endif  //  TEDDY_TEST_TEST_LAYER_H


