
/*
    TEDDY - General graphics application library
    Copyright (C) 1999, 2000  Timo Suoranta

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    Timo Suoranta
    tksuoran@cc.helsinki.fi
*/


/*!
	\class   ThreadMaster
	\ingroup g_testing_environment
	\author  Timo Suoranta
	\brief   Controls testing environment threads and semaphores
	\date    2000
*/


#ifndef TEDDY_TEST_THREAD_MASTER_H
#define TEDDY_TEST_THREAD_MASTER_H


#include "SDL.h"
#include "SDL_thread.h"
#include "Graphics/View.h"
#include "Physics/System.h"
using namespace Graphics;
using namespace Physics;


class ThreadMaster {
public:
	ThreadMaster( View *view, System *system );
	~ThreadMaster();

protected:
	SDL_TimerID  simulation_timer;
};


#endif  //  TEDDY_TEST_THREAD_MASTER_H

