
/*!
	\file
	\brief Main include file for the polymessage MIDI playback app.
	
	THIS CODE AND INFORMATION IS PROVIDED "AS IS" WITHOUT WARRANTY OF
	ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED
	TO THE IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR FITNESS FOR
	A PARTICULAR PURPOSE.
	
	Copyright (C) 1993 - 1997 Microsoft Corporation. All Rights Reserved.
*/


#ifndef TEDDY_WIN32_MIDIPLYR_H
#define TEDDY_WIN32_MIDIPLYR_H


extern void midi_init      ();
extern void midi_open_file ( char *fname );
extern void midi_cleanup   ();
extern void midi_play      ();
extern void midi_stop      ();
extern void midi_pause_stop();
extern void midi_pause_play();


#include <windows.h>
#include <windowsx.h>
#include <mmsystem.h>
#include <ctype.h>
#include "debug.h"
#include <stdio.h>
#include "seq.h"

extern  PSEQ            gpSeq;


#define MAX_FILEPATH        256

/* Number and size of playback buffers to keep around
*/
#define C_MIDI_BUFFERS      4
#define CB_MIDI_BUFFERS     1024


#endif  //  TEDDY_WIN32_MIDIPLYR_H

