
/*
    TEDDY - General graphics application library
    Copyright (C) 1999, 2000  Timo Suoranta

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    Timo Suoranta
    tksuoran@cc.helsinki.fi
*/


/*!

\page p_misc Misc Information


\section s_list_of_known_bugs List of known bugs


<ul>
<li>There is no edge treshold for smoothed objects; all verts are equally smooth. Looks bad.
<li>Polygons from LightWave are not tesselated. Some polygons don't work in the logo,
    in addition to above smoothing problem.
<li>Linux and Win32 versions seem to behave differently on Lightwave object polygon
    sidedness. Could be different behaviour between Matrox ICD / Microsoft GDI OpenGL and
	software Mesa 3.3 on Linux?
<li>LightWave object loader does not handle textures or much else
</ul>


\section s_history History


<ul>
<li>December 14. 2000. First tests with multithreading
<li>December  5. 2000. Simplified test scene, changed Renderable interface and Materials
<li>November 14. 2000. Improved LightWave importer slightly, some new documentation
<li>October  31. 2000. Cleaned up OpenGL feature usage, Material, noticed sorting with map problem
<li>October  24. 2000. Working on linux port and linux autoconf
<li>October   3. 2000. Finished integrating ROAM and improving LW loader
<li>August   19. 2000. I got married!
<li>July     30. 2000. Added view volume culling, screen space drag and radar, fixed view resize
<li>July      4. 2000. Simple Dock implementation now working
<li>July      1. 2000. My brother Esa got married :)
<li>June     22. 2000. Busy studies and work :(
<li>June     15. 2000. Simple button component working
<li>June     11. 2000. Working on physical userinterface components
<li>June      9. 2000. Fixed font, now using namespaces
<li>May      25. 2000. Release with planets of solar system in scene.
<li>May      22. 2000. Fixed depth buffer, lighting and materials.
<li>May      10. 2000. Elite flight model and lighting support back.
<li>May       2. 2000. Major code rearrangements and cleanups. 
<li>March    21. 2000. Took surface ship models from Elite - The New Kind.
<li>March    17. 2000. Working on documentation, fixed skybox (removed visible edges).
<li>March    16. 2000. Reorganized source, new modules. Overlay window broken.
<li>March    14. 2000. Working on documentation.
<li>March     3. 2000. Slowly recovering from flu. Released buggy beta test.
<li>February 17. 2000. Uploaded Amiga tests. Working with skybox and Elite ship models.
<li>February 15. 2000. Added selecton with mouse and detail level options.
<li>February 11. 2000. Made Beos port. Fixed OpenGL context misuse.
<li>February  9. 2000. Added skybox, fixed Z-buffer and few other things, cleanups.
<li>February  3. 2000. FrontView now offers Elite like camera movement.
<li>February  1. 2000. Page modified, working on plans.
<li>January  26. 2000. Too little time, only fixes to font rendering and surface processing.
<li>January  19. 2000. Decided to test spaceflight. No test out yet.
<li>January  10. 2000. Working on lineset to surface model converter.
<li>January   6. 2000. Added font engine. Improved DXF ascii reader.
<li>January   4. 2000. Added simple DXF ascii reader. Added rest of Elite ship models.
<li>January   3. 2000. Fixes to camera and lights.
<li>December 17. 1999 - January 1. 2000. Holiday.
<li>December 16. 1999. Fixes to LW classes.
<li>December 14. 1999. New classes: Scene, Camera, Light, Material, Texture,
    Element, LWObject, LWSurface, LWComponent, LWTexture. All translations
    and rotations now with mouse.
<li>December  7. 1999. Wrote a rotating Cobra Mk III Screen Saver for win32.
<li>December  6. 1999. Camera rotation with mouse, model selection, creating new instance of selected model.
<li>December  3. 1999. Mouse control, cleaned up code, wrote some documentation.
<li>December  2. 1999. Smooth faces, triangle subdivision, animation.
<li>December  1. 1999. Face normal calculations and tested flat shading. 
<li>November 30. 1999. Tested matrix class. Added Krait ship model. 
<li>November 29. 1999. First entry. I wrote the test during last weekend
</ul>


	So, here's the scroller. Sorry, this isn't a true
	sinus oldskool scroller.. but I thought they aren't
	that hot any more.

	A brief note that in this demo I will completely
	neglect textures. Nothing is textured in this demo :)

	A long time age - early 90s - there used to be these
	'realtime fractal' routines, which looked cool. These
	days we have the processing power to do these things
	truly in realtime - also hard realtime in it's true
	meaning. So let's have a look!

	This routine is based on ROAM algorithm with fractal
	mesh. Landscape data is calculated in 'realtime' - on
	the fly - with Ken Musgraves multifractal algorithms,
	which use Perlin noise for example. Originally Sean
	O'Neil wrote this variation of ROAM which provides
	3D-sphere like mesh instead of flat 2D heightfield
	scenery.

	Baby-D - I miss your music! I lost almost all mods :(

	Azazel - Your music is great too, I hope you get
	broader success someday

	Bass Cadet - When You asked what kind of music I'd
	like to get, forget it. One should always what he
	can do best. So thats my revised answer :)

	Commercial break

	<url to bass cadet site>

	I've always like lighting effects. The previous
	effect used a few lightsources instead of more usual
	single lightsource. It was nicer that way. Now, let's
	have a look at some more obvious lighting tricks.

	Alpha blending is name of the game here. Lens flares
	have been here since Silent's demo ??? from Assembly.
	Modern games use some effects like this for weapons
	and explosions. Key is to use additive alpha, for
	OpenGL, alphafuncs GL_ONE, GL_ONE.

	I hope you will like this one!

	<machine-gun like rotating laser beams>

	All these would be much easier to do with textures,
	but they are specifically avoided this time :)

	Ok so you've written a LightWave scene player? Sure
	it'll look good^t^t^t^tok. But I think it's about
	time to get something new..


*/
