
/*
    TEDDY - General graphics application library
    Copyright (C) 1999, 2000  Timo Suoranta

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    Timo Suoranta
    tksuoran@cc.helsinki.fi
*/


/*!

\mainpage Teddy Reference Manual


\section mp_introduction Introduction


While original plan was to create OpenGL version of Elite,
current development is focused on making modular, generic
opensource space-roleplaying framework. <i>Teddy</i> is
project name for the framework. <i>glElite</i> is project
name for the spacegame of original idea.

TEDDY (while also being acronym for something..) stands
for <b>General graphics application library1</b>. It is
called such because it is 'just' a collection of routines
related to graphics applications that use OpenGL and are
capable of doing simulation.

TEDDY is acronym for 'The Embassy Demo Development
Ymprist'. Ymprist is Finnish word meaning environment.
Original plan for TEDDY is to be implemented later, if
ever.

glElite is project plan to create OpenGL version of Elite.
Since Elite is copyrighted, and glElite clearly would contain
material from Elite, it will be impossible to publish glElite
under Gnu Public license. Currently I am not working on glElite.
If someone does the boring job for me and tells me which license
to use, and how, it will be possible to continue work on glElite.
Based on Elite - The New Kind and Teddy, it should be possible to
finish glElite.


\section mp_current_status Current status


<p>
Teddy currently uses
<a href="http://www.devolution.com/~slouken/SDL/">Simple Directmedia Layer</a>
to access OpenGL in platform independent way.
</p>

<p>
Features currently implemented:
</p>

<ul>
<li>Vector, Matrix and Quaternion establish stable foundation for 3D mathematics
<li>Element is baseclass for object parts. Vertex, Line, Face etc. are Elements
<li>Mesh is baseclass for object shape. PolygonMesh, LineMesh etc. are Meshes
<li>Materials module provides Material and Light for material properties
<li>ModelInstance contains Mesh and transformation matrix for invidivual mesh instances
<li>Scene is collection fo ModelInstances and Lights
<li>Cameras can be used to view Scenes
<li>LWMesh can load LWOB and LWO2 files (also LWLO, but layers inn LWLO and LWO2 are not yet done)
<li>Physics::System manages simple RigidBody simulation
<li>PhysicalComponents:: provide multiple 2D and 3D windows in single OpenGL context
<li>Userinterface features logical styles, input focus with some primitive widgets.
<li>Realtime optimally adapting mesh routine generates landscape mesh in realtime
(Sean O'Neil)
<li>Perlin noise and Fractal classes are being used to generate fractal landscape
(Sean O'Neil) and fractal textures.
</ul>

<p>
Currently in the TODO list:
</p>

<ul>
<li>Apply vertex arrays to ROAM
<li>Apply compiled vertex arrays to LWMesh
<li>Experiment with alpha blending effects
<li>Ship AI, autopilot
</ul>

  
\section mp_documentation_for_users Documentation for Users


At the moment glElite has little functionality, and the
testing environment will have nothing to do with final
gaming environment. User documentation at the moment
only coverts the testing environment.

<ul>
<li>\link p_usage Usage for glElite Testing Environment\endlink
<li>\link p_links Links\endlink
</ul>


\section mp_documentation_for_developers Documentation for Developers


This documentation does not cover C++, STL, SDL or OpenGL -
You have to use other resources if you need information about them.
<a href="http://www.opengl.org>http://www.opengl.org</a>
OpenGL homepage is good startingpoint for OpenGL, for example.

Teddy / glElite is mostly developed in Microsoft Visual
Studio C++ version 6 - Workspace and Project files are included.
Generally, a C++ compiler with STL support, OpenGL, glu and SDL
is required. It should be trivial to build with any compiler and
on any platform (for which SDL port with OpenGL support exists).
Autoconf configure script for my university linux is included.
It should work, but please let me know if it does or does not.

There are some features like Timer class which have platform
specific implementations, separate for Win32 and Linux at the
moment. I should rewrite them using SDL. To be done.

<ul>
<li>\link p_program_flow Program Flow\endlink Read this first
<li>\link p_implementation Implementation\endlink
<li>\link p_misc Known bugs and History\endlink
<li>\link p_links Links\endlink
</ul>


\section mp_contact_information Contact Information


Timo Suoranta<br>
Kilonrinne 10 E 101<br>
02610 Espoo<br>
Finland<br>

Email: <a href="mailto:tksuoran@cc.helsinki.fi>tksuoran@cc.helsinki.fi</a><br>
My Homepage: <a href="http://www.helsinki.fi/~tksuoran/">http://www.helsinki.fi/~tksuoran/</a><br>
glElite Homepage: <a href="http://glelite.sourceforge.net">http://glelite.sourceforge.net</a><br>
Gsm: +358-40-5629512


\section mp_about_this_documentation About This Documentation


This documentation has been extracted from source files with
<a href="http://www.stack.nl/~dimitri/doxygen/index.html">Doxygen</a>
version 1.2.2 by <a href=mailto:dimitri@stack.nl>Dimitri van Heeschs</a>.

*/
 
