
#include "ui.h"
#include "Graphics/GlFeature.h"


void UI::polygonModeLine(){
	*console << "Polygon Mode Line";
	console->newLine();
	view->setPolygonMode( GL_LINE );
	scene->update( front_camera );
}


void UI::polygonModeFill(){
	*console << "Polygon Mode Fill";
	console->newLine();
	view->setPolygonMode( GL_FILL );
	scene->update( front_camera );
}


void UI::cullFaceEnable(){
	*console << "Master Face Culling Enabled";
	console->newLine();
	GlFeature::cull_face.masterEnable();
	GlFeature::cull_face.apply( true );
	scene->update( front_camera );
}


void UI::cullFaceDisable(){
	*console << "Master Face Culling Disabled";
	console->newLine();
	GlFeature::cull_face.masterDisable();
	scene->update( front_camera );
}


void UI::depthTestEnable(){
	*console << "Master Depth Test Enabled";
	console->newLine();
	GlFeature::depth_test.masterEnable();
	GlFeature::depth_test.apply( true );
	scene->update( front_camera );
}


void UI::depthTestDisable(){
	*console << "Master Depth Test Disabled";
	console->newLine();
	GlFeature::depth_test.masterDisable();
	scene->update( front_camera );
}


void UI::lightingOn(){
	*console << "Master Lighting Enabled";
	console->newLine();
	GlFeature::lighting.masterEnable();
	scene->update( front_camera );
	GlFeature::lighting.apply( true );
}


void UI::lightingOff(){
	*console << "Master Lighting Disabled";
	console->newLine();
	GlFeature::lighting.masterDisable();
	scene->update( front_camera );
}


void UI::fovNormal(){
	*console << "Normal Field of Vision";
	console->newLine();
	camera->setFov( 60.0 );
}


void UI::fovWide(){
	*console << "Wide Field of Vision";
	console->newLine();
	camera->setFov( 120.0 );
}


void UI::antialiseOn(){
	*console << "Line Smooth Hint Nicest";
	console->newLine();
	glHint( GL_LINE_SMOOTH_HINT, GL_NICEST );
	GlFeature::line_smooth.masterEnable();
	GlFeature::blend.masterEnable();
	scene->update( front_camera );
}


void UI::antialiseOff(){
	*console << "Line Smooth Hint Fastest";
	console->newLine();
	glHint( GL_LINE_SMOOTH_HINT, GL_FASTEST );
	GlFeature::line_smooth.masterDisable();
	GlFeature::blend.masterDisable();
	scene->update( front_camera );
}

