//
//   Copyright (c) 1999-2000 Intel Corporation.
//
// Permition is granted to use, copy, distribute and prepare derivative works 
// of this library for any purpose and without fee, provided, that the above 
// copyright notice and this statement appear in all copies.  
// Intel makes no representations about the suitability of this software for 
// any purpose, and specifically disclaims all warranties. 
// See LEGAL.TXT for all the legal information.
//

#ifndef _BEZIER_H__
#define _BEZIER_H__

#include "bezierspline.h"


class CScene;

class CBezierPatch {
protected:
	DWORD			m_indices[4][4];
	CBezierSpline	*m_spline;
	static  DWORD	GetTessalationOrder(float minZ);
	virtual bool	EvalSurface(LPDIRECT3DVERTEXBUFFER7 vb,CScene *scene,LPWORD &indices,DWORD &indicesCnt);
public:
	CBezierPatch(CBezierSpline *spline,DWORD *indices);
	virtual ~CBezierPatch();

	virtual bool Render(CScene *scene,LPDIRECT3DVERTEXBUFFER7 vb,LPWORD &indices,DWORD &indicesCount);

};




#endif //_BEZIER_H__
 

