#include "Common.h"

#define CPUID _asm _emit 0x0f _asm _emit 0xa2 	

#define SSE_PRESENT 0x02000000
#define MMX_PRESENT 0x00800000


BOOL CheckIfSSE() {
	DWORD RegisterEAX;
	DWORD RegisterEDX;
	char VendorId[12];
	const char IntelId[13]="GenuineIntel";

	__try
	{   
		_asm {
	    xor		eax,eax
	    CPUID
		mov		RegisterEAX, eax
		mov		dword ptr VendorId, ebx
		mov		dword ptr VendorId+4, edx
		mov		dword ptr VendorId+8, ecx
		}
	} __except (1)
	{
		return FALSE;
	}

	// make sure EAX is > 0 which means the chip
	// supports a value >=1. 1 = chip info
	if (RegisterEAX == 0)
		return FALSE;
	
	// make sure chip is "GenuineIntel"
	for (int i=0; i<12; i++)
		if (VendorId[i] != IntelId[i])
			return FALSE;

	// this CPUID can't fail if the above test passed
	__asm {
		mov eax,1
		CPUID
		mov RegisterEDX,edx
	}
	
	if ((RegisterEDX  & SSE_PRESENT) && (RegisterEDX & MMX_PRESENT))
		return TRUE;
	
	return FALSE;
}





