#ifndef PLANET_H__
#define PLANET_H__

#include "pipe_def.h"
#include "utils.h"

class CScene;

class CPlanet {
private:
	D3DMATRIX	m_World;
	D3DMATRIX	m_iWorld;
	BOOL m_Recalc;
	SVertex		*m_AOSData;
	SSimdVertex *m_SOAData;
	WORD		*m_Indices;
	D3DTLVERTEX *m_Out;
	void		*m_SOAUnalignedMem;
	void		*m_OutUnalignedMem;
	DWORD		m_nVerts;
	DWORD		m_nIndices;
	SColor		m_Ambient;
	SColor		m_Material;

	void GenerateSphere(int LOD);
	void FillSOAData();
	LPDIRECT3D	lpd3d;
	LPDIRECT3DTEXTURE2 lpd3dTex;
public:
	const D3DMATRIX& GetWorldMatrix() {return m_World;}
	SVertex		*GetAOSData() {return m_AOSData;}
	SSimdVertex *GetSOAData() {return m_SOAData;}
	WORD		*GetIndices() {return m_Indices;}
	DWORD		GetVertexCount() { return m_nVerts;}
	DWORD		GetIndexCount() {return m_nIndices;}
	D3DTLVERTEX *GetOutputBuffer() {return m_Out;}
	BOOL		Changed() {return m_Recalc;}
	void		SetAmbientColor(const SColor &col) {m_Ambient = col;}
	void		SetMaterialColor(const SColor &col) {m_Material = col;}
	SColor		GetMaterialColor() {return m_Material;}

	void  SetWorldMatrix(D3DMATRIX& mat);
	const D3DMATRIX& GetIWorldMatrix();
	CPlanet(int LOD = 35);
	~CPlanet();
	void BasicPipeline(CScene *scene);
	void SimdPipeline(CScene *scene);
	void Render(LPDIRECT3DDEVICE2 lpd3dDev);

	friend class CScene;
};

#endif

