#ifndef SCENE_H__
#define SCENE_H__


#include "common.h"
#include "d3dtex.h"
#include "planet.h"

#define MAX_LIGHTS 10

class CScene {
private:
	CPlanet		m_Moon;
	CPlanet		m_Earth;
	CPlanet		m_Sun;
	CPlanet		m_Venus;
	CPlanet		m_Mars;
	D3DMATRIX	m_View;
	D3DMATRIX	m_iView;
	D3DMATRIX	m_Proj;
	D3DMATRIX	m_Comp;
	CWindow		*lpd3dWindow;
	// to bring to screen coordinates;
	BOOL		m_Recalc;
	D3DTexture  m_EarthTex;
	D3DTexture  m_MoonTex;
	D3DTexture  m_SunTex;
	D3DTexture  m_BackTex;
	SLight		m_Lights[MAX_LIGHTS];
	DWORD		m_nLights;
	int			mode;
public:
	void ChangeMode() {mode  = !mode;}
	void SetMode(int x) {mode  = x;}
	SLight GetLight(int i);
	DWORD GetLightCount();
	CScene();
	~CScene();
	void SetViewMatrix(D3DMATRIX &mat);
	void SetProjMatrix(D3DMATRIX &mat);
	const D3DMATRIX& GetCompositeMatrix();

	HRESULT Init(CWindow *lpd3dWin);
	HRESULT Fini();
	HRESULT InitViewport();
	HRESULT FiniViewport();
	HRESULT Render();
	HRESULT Restore();

	HRESULT	AddLight(SLight &light);

};





#endif
		

