#ifndef UTILS_H__
#define UTILS_H__

#include <d3d.h>
#include <d3dtypes.h>
#include "pipe_def.h"

extern const float pi;

extern SVector VectorNormalize(const SVector & v);
extern float rand01();

extern D3DMATRIX ZeroMatrix(void);
extern D3DMATRIX IdentityMatrix(void);
extern D3DMATRIX RotateXMatrix(const float rads);
extern D3DMATRIX RotateYMatrix(const float rads);
extern D3DMATRIX RotateZMatrix(const float rads);
extern D3DMATRIX TranslateMatrix(const float dx, const float dy, const float dz);
extern D3DMATRIX ScaleMatrix(const float a, const float b, const float c);
extern D3DMATRIX MatrixMult(const D3DMATRIX & a, const D3DMATRIX & b);
extern D3DMATRIX MatrixInverse(const D3DMATRIX & m);


#endif
