#ifndef WIN_H__
#define WIN_H__

#include "common.h"

class CScene;

#define WIDTH 640	
#define HEIGHT 480

LRESULT CALLBACK DlgAboutProc (
	    HWND    hWindow,
	    UINT    uiMsg,
	    WPARAM  wParam,
	    LPARAM  lParam);

class CWindow {
private:
	BOOL Animate;
	HWND				hWnd;
    LPDIRECTDRAW		lpDD;               
    LPDIRECTDRAW2		lpDD2;              
    LPDIRECT3D2			lpD3D;              
    
    LPDIRECTDRAWSURFACE  lpddsPrimary;  // Primary Surface

    LPDIRECTDRAWSURFACE  lpddsRender;   // Rendering surface
    LPDIRECTDRAWSURFACE  lpddsZBuff;    // Z-Buffer surface
    LPDIRECT3DDEVICE2    lpd3dDevice;	// D3D Device
	LPDIRECT3DVIEWPORT2  lpd3dViewport;	// D3D Viewport
	CScene				 *lpScene;
	BOOL				 InitFinished;
public:
	void DrawScene();
	void OnPaint(HDC hdc);
	void OnCommand(WPARAM wParam);
	CWindow() : InitFinished(FALSE),Animate(TRUE) {}
	BOOL isInit() {return InitFinished;}
	void Init();
	void Fini();
	void InitDirect3D();
	void FiniDirect3D();

	static LRESULT CALLBACK SolarSystemProc (
	    HWND    hWindow,
	    UINT    uiMsg,
	    WPARAM  wParam,
	    LPARAM  lParam);


	void OnIdle();

	friend class CScene;
};







#endif
